# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

    
# 27.5.0 (2025-06-24)


### Bug Fixes

* **A11Y-3176:** Rectangle and Ellipse - add keyboard accessibility (c317f5d)
* **SCP-76154:** Single Value - fix trend percentage not showing floating point decimal places (8d9df87)
* **SPL-273931:** Map - add check to ensure metadata exists before reading field - marker layer (6b38d76)


### Features

* **SCP-74849:** Map - add tooltip header field option (379a92b)
* **SCP-74855:** Axis Charts - add additionalTooltipFields (959d094)
* **SPL-272033:** FieldSummary - update tooltip warning message for SPL2 datasources (d678cfd)




# 27.4.0 (2025-05-27)


### Bug Fixes

* **SCP-74590:** Timeline - fix duration number conversion (7022db4)
* **SCP-75615:** Marker gauge and Filler gauge - fix gauge font color across themes (72dc486)


### Features

* **SCP-73705:** Pie - add trellis (b951722)
* **SCP-73708:** Scatter - enable trellis layout (9a79a08)
* **SCP-74851:** Map - option to remove lat and lon from tooltips (f505de0)




# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.


# 27.3.0 (2025-04-15)


### Bug Fixes

* **A11Y-3135:** Events - add focus effect to show as raw text button (ce6c719)
* **DMX-13216:** patch numbro node package to fix negative duration (9ae6f1d)
* **SCP-74335:** Timeline - add hover styles to timeline lane (d27c82a)
* **SCP-74584:** Timeline - add i18n to timeline x-axis (8935ebb)
* **SCP-74587:** Timeline - x axis should use splunk font (9ecf6bd)

### Dependency Updates 

* Update ```@splunk-charting``` to 2.3.1 (f2ecc597) which includes:
* **SCP-73658:** Line/Area Y-Axis incorrect tickmarks inplace update




## 27.2.1 (2025-03-04)


### Bug Fixes

* move @splunk/react-docs to devDependencies (c00129a)


# 27.2.0 (2025-03-04)


### Bug Fixes

* **A11Y-3006:** Events - accessibility fixes (3c5c386)
* **A11Y-3008:** Link Graph - keyboard nav fixes (34a00fa)
* **A11Y-364:** Punchcard - operable with keyboard (94fcb73)
* **SCP-73992:** Table - sparklines can use floating point (95107e2)
* **SCP-74343:** Timeline - truncate yAxisLane overflow text (5d6e230)



### Features

* **SCP-72921:** SV, SVR, SVI - add majorValueDisplay option (5dc4289)
* **SCP-73188:** Map - add dynamic coloring UI - bubble layer (257e5fc)
* **SCP-73444:** Map - add dynamic coloring UI - marker layer (e539845)
* **SCP-60996:** Timeline - new visualization (049b49f0)





# 27.1.0 (2025-01-21)


### Bug Fixes

* **SCP-62702:** SVR - update min sizes (20277bf)
* **SCP-72751:** SV, SVR, SVI - handle percent values for trendColor (a168c6e)
* **SCP-73461:** trellis editor config no longer uses hooks (aae0c12)
* **SCP-73491:** support 3, 4, 6, and 8 digit color codes (dc21701)
* **SCP-73753:** Area, Column, Bar, Line - disable y2 and overlay editor when trellis is on (b24d10d)
* label name corrected under Y2-axis grid and labels (f2772b2)


### Features

* **SCP-70843:** Area, Column, Bar - add lineDashStyle and lineDashStylesByField for overlay lines (8e6e63c)
* **SCP-63834:** Area, Column, Bar, Line - add trellis (5cd36738)
- feat(SCP-57335): turn off legend for charts when trellis on
- feat(SCP-69303): add trellis for area
- feat(SCP-69304): add trellis for column
- feat(SCP-69306): add trellis for bar
- feat(SCP-69307): add trellis for line
- feat(SCP-72949): trellis add shared axis
- feat(SCP-70201): trellis editor changes
- feat(SCP-70197): add trellis payload to splunk charting
- fix(SCP-72971): fix legend editor when trellis is on
- docs(SCP-73262): add trellis docs





# 27.0.0 (2024-12-10)


### Bug Fixes

* **A11Y-347:** remove redundant titles from visualization type icons (b51dfe4)


### Features

* **SPL-264163:** trigger viz.renderedWithData event when charting visualizations render (acedf46)


### BREAKING CHANGES

* **SCP-71246:** Deprecated packages `@splunk/dashboard-visualizations`, `@splunk/react-visualizations` and `@splunk/visualization-encoding-parsers` have been removed and no longer published. (0ffef6f)





# 26.4.1 (2024-11-04)

### Bug fixes
-   Revert **SCP-43849:** table - display readable time format by default (e402299)

### Performance Improvements

* **SPL-264163:** Telemetry - trigger viz.renderedWithData event when charting visualizations render (dc14b9d)


### Features

* **SPL-264163:** trigger viz.renderedWithData event when charting visualizations render (dc14b9d)





# 26.4.0 (2024-10-29)


### Bug Fixes

* **SCP-72505:** runtime validation errors Table schema (2613af3)
* **SPL-259611:** remove check for y2 field (34edb4d)
* **SPL-264152:** uptake splunk charting 2.2.4 with downsample bug fix (f115c76)
* **SCP-71752:** Map - autozoom when zoom and center are undefined (5410502)
* **SCP-66672:** Map - undo zooms to 0 instead of autozoom to fit layer data (5410502)
* **SCP-63542:** Map - does not update center config when dashboard first loads in view mode (5410502)


### Features

* **SCP-37117:** adds support of (*) wildcard in DSL MatchValue (5b822ba)
* **SCP-43849:** table - display readable time format by default (e402299)
* **SCP-69584:** pie - consolidated slice display option (fc0c5c9)
* **SCP-70210:** single value - option and UI to abbreviate major value (b1bcab2)
* **SCP-72621:** change label for background color editor from 'Background' to 'Background color' (ed4bb61)
* **SPL-259705:** Support downsampling on charts that coerce nulls to zeroes (293dca5)
* **SCP-62607:** Map - add fit to data button to auto center and zoom (5410502)




# 26.3.0 (2024-09-17)


### Features

* migrate visualization schemas and tools to a new shared package (63a672c)





## 26.2.1 (2024-08-08)


### Dependency Updates

* update @splunk/react-icons to v4.6.0 (e01e3bdf)



# 26.2.0 (2024-08-06)


### Bug Fixes

* **SCP-71020:** ChoroplethSVG - force redraw of iframes (ab9ab03)
* **SCP-70683:** Table - fix column resize issue (3bf7bf6)
* **SCP-71645:** Table - fix columnFormatting for renamed headers (19704af)


### Features

* **SCP-48666:** Table - add header alignment options and editor ui (b7cff57)
* **SCP-70998:** Table - add editing ui for text alignment (bb49214)
* **SCP-38400:** Table - add editing UI for text wrap configurations (bc6382a)
* **SCP-69605:** Table - add support for string values for alignment (19091a5)
* **SCP-23987:** SingleValue - add left, center, and right alignment (ff09538)

### Performance Improvements

* **SPL-242541:** Downsample Time Series Charts (209cfca7)
* **SCP-69764:** DSL Performance Improvements (f476d6ab) 


### Dependency Updates

* update @splunk/react-ui to v4.33.0 (3bf7bf6d)



# 26.1.2 (2024-06-27)

### Performance Improvements

* **SCP-62617:** Table - memoize drilldown handler (672f3421)



# 26.1.1 (2024-06-24)


### Bug Fixes

* **SCP-68788:** Map - fix invalid prop warning (5ea56c3)
* **SCP-70910:** Punchcard - handle null and invalid values (4417ea3)


### Performance Improvements

* **SCP-62659:** Line - refactor computeVizProps (4c66514)


### Dependency Updates 

* Update ```@splunk/react-events-viewer``` to 5.4.5 (7dbd2f82) which includes
* **SCP-70847:** Fix dependencies in react-events-viewer

* Update ```@splunk-charting``` to 2.1.0 (7dbd2f82) which includes
* **SCP-70834:** highcharts.js duplicate loading issue
* **SCP-70362:** add option to remove range select on load




# 26.1.0 (2024-05-13)


### Bug Fixes

* **SCP-67814:** Single Value Icon - increase icon size (db96057)
* **SCP-68602:** Punchcard - fix max bubble value for numbers in string type (71bac7a)
* **SCP-70409:** d3-color vulnerability issue (44b12aa)


### Features

* **SCP-44318:** Sankey - expose click events for nodes and links (316d4d3)
* **SCP-69614:** Events - support highlighting from datasource (75fab14)
* Upgrade `react-events-viewer` to 5.4.4 (c6d654ff) which includes: 
* **SCP-63896:** Events - support wildcard values for highlighting





# 26.0.0 (2024-04-02)


### Bug Fixes

* **SCP-69407:** Table - column width only applied to first column when headerVisibility set to none (afb322f)
* **SCP-69575:** Map - works with empty fields and columns (5d01d59)
* **SCP-69640:** Table - add a11y title and role to table sparkline (c820e38)
* **SCP-68674:** DSL - limit webworkers (b88e24d)
* Table - support tabs and spaces (fa7f7b8)
* Table - sparkline first entry was invalid (5540363)
* **SCP-69880:** Upgrade `react-events-viewer` to 5.4.3 (4ad6c08e) which includes: 
* **SCP-64281:** Eventsviewer - Remove Eventsviewer field actions for _time
* **SCP-69730:** Eventsviewer - Eventsviewer can fetch more than 30 tags

### Features

* **SCP-64652:** Single Value Radial - introducing gauge (d96788a)


### Performance Improvements

* **SCP-62653:** Area Chart - review computeVizProps (24cddde)


### BREAKING CHANGES

* **SCP-69881:** @splunk/charting dependency upgraded to v2.0.0 which has Highcharts v9 upgrade. This has visual and DOM rendering differences for charting components.
* **SCP-64652:** Single Value Radial - removed match value (d96788a)





## 25.13.1 Maintenance Release (2024-03-04)


### Bug Fixes

* **SCP-69575:** Map - works with empty fields and columns (a09476e)





# 25.13.0 (2024-02-17)


### Bug Fixes

* **SCP-48847:** ChoroplethSvg - fix relative path svg load issue (c6d4e2a)
* **SCP-64968:** Map - hide tooltip rows with 0 values (7500527)
* **SCP-67387:** ChoroplethSvg - show custom error message for external url issue (d6539af)
* **SCP-67977:** Table - a11y - add aria-label for sparkline cells (7e116a6)
* **SCP-68004:** Single Value - a11y - add alternative text (e977793)
* **SPL-247176:** Table - fix cmd + click behavior on Firefox browser (059aa73)
* Upgrade `react-events-viewer` to (5.4.2)


### Features

* **SCP-68645:** Map - a11y - add aria-label to map container (d240188)
* **SCP-68814:** Events - add array type to highlightValuesByField (64f30dc)





# 25.12.0 (2024-01-10)


### Bug Fixes

* **SPL-248162:**  Map - add if guard around onMapLoad (8f76b8e)
* **SCP-68502:** SVR - remove underlabel stroke color (cc46f50)


### Features

* **SCP-63257:** mark viz names for i18n (f36d9b0)
* **SCP-67657:** Events - pass in onTagClicked handler that calls onEventTrigger (48e19e2)
* **SCP-67934:** Events - add feature flag enableEventsViewerTags (bd72d7b)
* **SPL-248162:** Map - update contract for onMapLoad (32bd80a)





# 25.11.0 (2023-11-07)


### Bug Fixes

* **SCP-64655:** Table and Events - render multi-line cell contents properly (051d516)
* **SCP-64699:** Single Value - underLabel font color (44192a0)
* **SCP-64969:** Map - tooltip fix for all null column (9c09a09)
* **SCP-65745:** Map - support undo after zoom interaction (240edd7)
* **SCP-65876:** MarkerGauge and FillerGauge - center window alignment (fb8cc53)
* **SCP-66659:** Map - fix for set token not working in first run (3bc1446)
* **SCP-66714:** Scatter - fix type error when data is not available (004a351)
* **SCP-66982:** Single Value Radial - major value alignment improvement (e02adf6)
* **SPL-239830:** Editor - tag strings for i18n (8e32f9e)


### Features

* **SCP-66838:** Map - enable cooperative gestures (267609d)





# 25.10.0 (2023-09-18)


### Bug Fixes

* **SCP-65289:** map - fix zoom in icon when using dark mode (71f1d86)
* **SCP-65681:** map - remove choropleth unwanted markers (9ba2c18)
* **SCP-65941:** table - links now appear clickable with prisma theme (1be8e0f)
* link graph - allows for space only names for nodes (5c9ce72)

### Features

* **SCP-59636:** link graph - support for blank values in columns (7355221)





# 25.9.1 (2023-08-07)


### Bug Fixes

* **SCP-62182:** Map - undo button works after adding map to dashboard (8100faa)
* **SCP-64184:** Single Value - trellis no longer missing data on safari (97f9566)
* **SCP-64185:** Table - fix incorrect pagination offset (72e2835)
* **SCP-65425:** Editors - correct button name of legend mode (fefaf00)
* **SCP-65444:** Editors - correct label name of trellis layout (1220079)


### Chores
* upgrade @splunk/react-ui to 4.17.0
* upgrade @splunk/react-icons to 4.0.1





# 25.9.0 (2023-07-06)


### Features

* Line - adds optional enable line smoothing (4abcd79)


### Performance Improvements

* cache the dataframe (b4c456d)
* halt unneeded resizes of charts (82a0f74)




## 25.8.1 Maintenance Release (2023-05-23)


### Bug Fixes

* ChoroplethSVG - no longer omitting transparent backgrounds in dark *system settings* (eab87bf)




# 25.8.0 (2023-05-16)


### Bug Fixes

* **SCP-63801:** no longer skipping webworkers for cloned visualizations (b093c6e)
* **SCP-63802:** improved webworkers with trellis layouts (8978579)
* **SCP-64081:** no longer displaying flickering when webworkers are enabled (776bbc9)
* **SCP-63551:** no longer using ampersands in labels (653a0a6)
* **SCP-63658:** ChoroplethSVG - no longer omitting transparent backgrounds in dark mode (7e8daa5)
* **SCP-64159:** Link Graph - improved editor labeling (722e938)
* **SCP-57903:** Map - no longer omitting zoom levels above 9 for custom tilesets (6fc1297)
* **SCP-55346:** Table - improved column width adjustments after exiting full screen (a67c5f3)
* **SCP-55828:** Table - no longer omitting field names with a period in column width configurations (12ba505)
* **SCP-56010:** Table - no longer omitting header rows in text overflow configurations (1b3d7c9)
* **SCP-61783:** Table - improved contextual column resizing interactions (6af724e)
* **SCP-63210:** Table - improved row numbering during pagination (89a1441)
* **SCP-63259:** Table - improved text overflow formatting (735ec9f)
* **SCP-63944:** Table - no longer displaying sorting interactions for the row number column (1682c48)
* **SCP-62360:** Table - no longer aligning number 0s to the left (5138e7e)
* **SCP-64200:** Table - assign default initial column width to horizontally scroll the content(b7cd0522)

### Features

* **SCP-63603:** Map - includes configuration UI for static series coloring (12de75c)


### Performance Improvements

* **SCP-62623:** Table - no longer deep clones table props on every render (89cf88d)





## 25.7.2 (2023-04-21)
### Bug Fixes

* **SCP-57903:** map - unconstrain zoom levels for custom tilesets (207b97c0)
* **SCP-63658:** choroplethSVG - enable background transparency in dark modes (884f42d2)



## 25.7.1 (2023-04-10)




**Note:** Version bump only for package @splunk/visualizations


# 25.7.0 (2023-04-04)


### Bug Fixes

* **SCP-59309:** choropleth svg - enable svg resizing (fee991a)
* **SCP-62483:** table - configuration cleanup (df6f70e)
* **SCP-62512:** update general visualizations configuration ui (b6071fa)
* **SCP-62577:** single value visualizations - configuration ui cleanup (e72da7e)
* **SCP-62690:** linkgraph - configuration ui cleanup (b9480ae)
* **SCP-62801:** trellis - fix config ui for trellis visualizations when disabled (d44444b)
* **SCP-62802, SCP-62803:** trellis - timechart trellisSplitBy issue for multiple aggregations and disabled "Value" config UI for SVI and SVR (11088d6)
* **SCP-63002:** shapes - update configuration ui (a98b7db)
* **SCP-63333:** trellis - SV showing N/A for stats/chart cmd (10320b6)


### Features

* **SCP-57306:** trellis - initial hoc code with datasplitter for timechart cmd and use in SV/SVR/SVI (dd72eae)
* **SCP-57307:** trellis - implement datasplitter for stats and chart cmds (0deaadc)
* **SCP-57310:** trellis - enable pagination (ad00654)
* **SCP-57313:** trellis - enable layout options (d51566c)
* **SCP-57329 :** trellis - implement helper function to implement trellis splitby editor (d7ed9e7)
* **SCP-57330:** trellis - enable editor config for ‘trellisSplitBy’ and layout options (fc6b8a7)
* **SCP-57332:** trellis - add trellis title to Single Value (SV/SVI/SVR) (0d0fd09)
* **SCP-57337:** trellis - support for splitBy aggregations timechart/ chart cmds (4110ca2)
* **SCP-57343:** trellis - event payload updates (afe71f8)
* **SCP-59366:** trellis - option rename showTrellis to splitByLayout (b9ce63b)
* **SCP-59637:** trellis - support aggregations for stats cmd (e6bacab)
* **SCP-60135:** trellis - implement trellisBackgroundColor option (14f3cd1)
* **SCP-60872:** trellis - support data spliting for generic cmds (table, makeresults etc) that are not stats/chart/timechart (47db960)
* **SCP-62218:** pie, SVI & SVR - update configuration ui (619cb00)
* **SCP-62264:** map - update configuration ui (3777cde)
* **SCP-62477:** map - add lat and long fields to click events (f9fa4ee)
* **SCP-62800:** singlevalue - improve SV error handling for missing majorValue (575c3dd)
* **SPL-234380:** events - use * key instead of default for field actions that should show for all fields (23c3f45)
* **SPL-235543:** events - handle _raw and _time field token replacement (2ea28f1)
* **SPL-236346:** events - add support for field and eventtype filtered actions (8260ab9)


### Performance Improvements

* **SCP-62620:** table - styles not calculated on every render (decfaeb)





# 25.6.0 (2023-02-22)


### Bug Fixes

* **SPL-235168:** Do not duplicate field actions in events when merging props and context (365f5bf)


### Features

* **SCP-55235, SCP-54465:** events - add time popover and actions (2aef1e7)
* **SCP-57200:** DSL evaluation can optionally be executed within a separate thread by enabling the feature flag `visualizations_useWebWorkersForDSL` (49140ee)
* **SPL-229606:** Add support for token replacement in events viewer (7672f84)





# 25.5.0 (2023-01-31)


### Bug Fixes

* **SCP-60997:** table - enter key on cell triggers click event (6383e72)
* **SCP-61000:** editor label sentence casing and avoid conflict with UDF panel naming (8e7c5eb)
* **SCP-61083:** update viz configuration names and groupings (2384b87)
* **SCP-61321:** events - fix a11y bug with field summary popover focus (47035c7)
* **SCP-61470:** link graph - works with special characters (444380c)


### Features

* **SCP-54464:** events - add value.click event payload (06362d0)
* **SCP-59248:** map - add option showBaseLayer (bbb4469)
* **SCP-59253:** map - add option showZoomControls (2938a82)
* **SCP-59254:** map (choropleth layer) - add option choroplethOpacity (63cf35b)
* **SCP-59255:** map (choropleth layer) - add choroplethEmptyAreaColor option (377862b)
* **SCP-59256:** map (choropleth layer) - add source option to look up local US and World geojson (b3206a5)
* **SCP-59261:** map - implement migration script for choropleth (b546613)
* **SCP-59616:** markdown - add custom font family support (55fc729)
* **SCP-59823:** map (choropleth layer) - add choroplethStrokeColor option (9777893)
* **SCP-61050:** markdown - add rotation support (fc770d0)
* **SCP-61262:** map - update editor UIs to include more options (dfb3852)
* **SCP-57650:** outlier - legend shows corresponding colors for outliers and bounds (a4eda28c)





# 25.4.0 (2022-12-01)


### Bug Fixes

* **SCP-55111:** map - fix options when no dataSources provided (4bb3e97)
* **SCP-59733:** map (choropleth) - ignore invalid geom region (a92f4ee)
* **SCP-60555:** table - array cell formatting and alignment with null column value (027304a)
* **SPL-232890:** Fix SVG titles (54eb017)


### Features

* **SCP-34993:** single value - update behavior when drilldown enabled (7d4f4b5)
* **SCP-58106:** Area/Bar/Column/Line - add editors to configure options: overlayFields, showLines, lineWidth, showOverlayY2Axis (6438c83)
* **SCP-54958:** outlier detection viz (48970b00)


## 25.3.6 Maintenance Release (2023-11-21)


### Bug Fixes

* **SCP-62800:** SV - improve error handling for missing majorValue (f9f870e)
* **SCP-64655:** Table and Events - render multi-line cell contents properly (46706ef)




## 25.3.4 Maintenance Release (2023-04-21)


### Bug Fixes

* **SCP-57903:** map - unconstrain zoom levels for custom tilesets (cf46b60)
* **SCP-63658:** choroplethSVG - enable background transparency in dark modes (0febda1b)


## 25.3.3 Maintenance Release (2023-01-18)


### Bug Fixes

* **SCP-60997:** table - enter key on cell triggers click event (6abbba3)
* **SCP-61000:** rename editor panels named "General" to avoid state conflicts in UDF and editor label sentence casing (178df95)
* **SCP-61321:** events - fix a11y bug with field summary popover focus (b7adc2b)


## 25.3.2 (2022-12-16)
**Note:** Version bump only for package @splunk/visualizations


# 25.3.1 (2022-11-30)


### Bug Fixes

* **SCP-60555:** table - array cell formatting and alignment (a90d1a47)
* **SCP-60824:** table - remove horizontal scrollbar (293c516c)


# 25.3.0 (2022-11-15)

### Features

* **SCP-58421:** markdown - add custom font size support (31fcc6c)
* **SCP-59915:** markdown - open markdown text section by default (e8dfc67d)
* **SCP-59788:** events - add support for highlighting field values (fe08ef0)


### Bug Fixes

* **SCP-59194:** area & line - only enable legend display editor when legend mode is `Standard` (c3ecda3)





# 25.2.0 (2022-11-01)


### Bug Fixes

* **SCP-55286:** table - fix for visualization not being selected clicking table header (c77ff1e)
* **SCP-57869:** Single Value - unit align to bottom of major value (SV/ SVI/ SVR) (63c08eb)
* **SCP-59638:** type _time fields to always be of type time (d4462da)
* **SCP-59647:** bubble & scatter - update seriesColorsByField option description (554568c)
* **SCP-58729:** map - address security issue related to types (d8235f6)


### Features

* **SCP-54212:** map (bubble layer) - add geo bounds in event payload (934dd84)
* **SCP-54454:** events - create the initial viz (843c8b8)
* **SCP-54457:** events - add icon and placeholder (993e133)
* **SCP-54498:** events - add field summary popover (2420dee)
* **SCP-54502:** events - update payload and use onEventTrigger (cc6ce9f)
* **SCP-54506:** events - add footer component (615ae9c)
* **SCP-55227:** events - add event actions support and option (32ca904)
* **SCP-55409:** events - add background color editor (b38790d)
* **SCP-56341:** events - add field actions support and option (a2adffb)
* **SCP-57299:** events - add actions to field summary popover (de679da)
* **SCP-59364:** events - prepare Events visualization for release (e4380a9)
* **SPL-229607:** events - add eventActions and fieldActions from EventsContext (a53738f)





# 25.1.0 (2022-10-03)


### Bug Fixes

* **SCP-55325, SCP-58132:** update visualizations to use rgba color pattern (b639c10)
* **SCP-57748:** update encoding executor to not create empty points (5b36e7a)
* **SCP-57871:** markdown - update behavior when drilldown is enabled (c330613)
* **SCP-57903:** map - enable more zoom for custom tile sets (6d33346)
* **SCP-58081:** editors - remove overlayFields in the editor UI (875fb9a)
* **SCP-58268:** map - stop definition update when in view mode (c3c93ed)
* **SCP-58090:** editors - some configuration UI labels are hidden (e8ff53d)
* **SCP-58275:** bubble & scatter - update Y option editor to single column selector (b156226)
* **SCP-58388:** table -  move header row below alternate rows in editor UI (4b503fc)
* retain isDynamicOption export (bc01a2c)


### Features

* **SCP-58396:** editors - add `seriesColors` editor to axes chart config UI (96570a1)
* **SCP-57063:** mobile - include field names with bubble sizes (e9993ce)
* **SCP-57323:** editors - add `seriesColorsByFieldEditor` to axis chart config UI (67f6a34)





## 25.0.1 (2022-09-15)


### Bug Fixes

* map - lat lon warning and bubbleSize issue with numeric string data input (d95dbb7)
* **SCP-57488:** add labels to editors for proper theming (6f26b20)
* **SCP-57661:** collapse all editor panels (712aa71)
* **SCP-57663:** Sankey - handle link values input with numeric string format (c18bc24)





# 25.0.0 (2022-08-30)


### Bug Fixes

* **SCP-53892:** visualization displays the original data value, and we move type coercion to the formatters (1cb8f97)
* **SCP-55894:** table - columns don't fill containing space (1a6288d)
* **SCP-55941:** map - fix bug where theme change removes choropleths (df6dd65)
* **SCP-57163:** map - choropleth should disappear on unmount (1291f07)
* exclude empty strings from string type detection (085142eb)


### Features

* **SCP-53936:** update the data type inference algorithm to be more robust and handle mixed data types and `NULL` values (268e433)
* **SCP-55374:** map - add choropleth layer pure map side (96a0979)
* **SCP-55375:** map - accept geojson data as valid type (15585b8)
* **SCP-55376:** map - add choropleth map platform side (eba945f)
* **SCP-55379:** map - add events on click for choropleth layer (1a80bf6)
* **SCP-55380:** map - add choropleth tooltip (d4761af)
* **SCP-55381:** map - add editorui for choropleth areaid and areavalue (345c743)
* **SCP-55767:** Area/Bar/Bubble/Column/Line/Scatter - add and regroup editors for option configurations (daecd28)
* **SCP-56309:** map - add geojson data type to priority list (7731ebd)
* **SCP-56423:** map - make choropleth tooltip follow mouse (d21098a)
* **SCP-56886:** markdown - drilldown support for splunk.markdown (c3e2351)
* **SCP-54315:** singlevalue - tab to clickable elements (c5d1325d)
* **SCP-54316:** singlevalue - enter key triggers onClick handler (c5d1325d)


### BREAKING CHANGES

* **SCP-55767:** Area/Bar/Bubble/Column/Line/Scatter - expose editor UI for configurations of most options and regroup the editors into new panels
* **SCP-54379:** Removed space-delimiter support for both overlayFields and y2Fields configuration options
* **SCP-35711:** infer data type from the search result meta data fields - `type`, if present
* **SCP-53892:** visualization displays the original data value, and we move type coercion to the formatters
* **SCP-53936:** update the data type inference algorithm to be more robust and handle mixed data types and `NULL` values
See the MIGRATION.md for more details




# 24.7.0 (2022-07-27)


### Bug Fixes

* **SCP-54560:** splunk.choropleth.SVG does not display in the dashboard (c50c616)


### Features

* **SCP-55859:** surface image.click event in docs (8b41842)





# 24.6.0 (2022-06-28)


### Bug Fixes

* **SCP-54193:** increase min and max bubble size for cluster maps (4b3fd81)
* **SCP-55109:** table - change font size and face editor to drop downs (7736cda)
* **SCP-55110:** table - change row height when changing font size (c75bf15)

### Features

* **SCP-53934:** font size for Table (7a50b718)





## 24.5.3 (2022-06-14)


### Bug Fixes

* map - respect zoom config on loading (cbd7d06)





## 24.5.2 (2022-06-09)


### Bug Fixes

* **SCP-55116:** table - column formatting and column resizing fix (50cd35f)
* **SCP-55213:** map zoom resets to default when initialized (66d6f30)





## 24.5.1 (2022-06-06)


### Bug Fixes

* **SCP-55134:** map - removes an error on dashboards when adding a data source to a newly added map visualization  (99edf7f)





# 24.5.0 (2022-05-31)


### Bug Fixes

* **SCP-53760:** Map component throws an error CSSLoader not found (151a7d5)
* **SCP-53911:** linkgraph nodes can contain line breaks (4d4b07b)
* **SCP-49223:** fix timezone formatting for Table (c4ad6e8)
* **SCP-49258:** fixes sankey link coloring behavior (9133964)
* **SCP-54005:** handle pie viz empty column data (461e25a)
* **SCP-53687:** SVI with remote image triggers two events (ce8ba53)
* **SCP-51280:** show placeholder when all values are invalid (221dd9b)
* **SCP-52562:** fix bgcolor default for choropleth in enterprise dark (2ebdc7a)
* update map option types so nested options are configurable in dashboard "code" editor (39742f3)


### Features

* **SCP-33203:** improve performance of table width adjustments (901d344)
* **SCP-48824:** Auto zoom and center and console warning fix (e5bca75)
* **SCP-50159:** additional Tooltip Fields + bug fixes (e6c7d9a)
* **SCP-51430:** update to multi-column selection editor (91c5d86)
* **SCP-53935:** add fontSize option to Markdown (a8780e8)
* **SCP-51207:** save map position when dragged (c35ab79)
* **SCP-51481:** update placeholder icon for choroplethsvg (002cf2d)





# 24.4.0 (2022-04-15)


### Bug Fixes

* make Map component exportable (da1a901)
* **SCP-51280:** show placeholder when all values are invalid (221dd9b)
* **SCP-52562:** fix bgcolor default for choropleth in enterprise dark (2ebdc7a)


### Features

* **SCP-47323:** include hidden fields in table payload (fa78363)
* **SCP-48824:** Auto zoom and center and console warning fix (e5bca75)
* **SCP-50264:** add map.click event payload (46015d0)
* **SCP-51481:** update placeholder images for viz components (5984d70)





## 24.3.5 (2022-04-05)




**Note:** Version bump only for package @splunk/visualizations


## 24.3.4 (2022-04-05)




**Note:** Version bump only for package @splunk/visualizations



## 24.3.3 (2022-03-22)

### Bug Fixes

-   **SCP-48687:** fixes SVG name and value discrepancy on hover (d0ef32d)
-   **SCP-49998:** support defaults set within array of object in option (42fd2a6)
-   **SCP-52015:** fix bubble render with null and negative values (a19219d)
-   **SCP-52098:** read zoom level constraints from MapStyle (10c173c)
-   **SCP-52112:** update regex to prevent Map from crashing in Safari (5a05ae6)
-   **SCP-52152:** fix tooltip calculation for negative decimal degrees (ace6d99)



## 24.3.2 (2022-03-16)

### Bug Fixes

-   **SCP-51504:** accept numbers for markdown (84743d5)



## 24.3.1 (2022-03-12)

### Bug Fixes

-   **SCP-51433:** Fix Map Tooltip to get correct count for Bubbles (8047a6d)
-   **SCP-51436:** Fix Map data selection error for latitude and longitude columns (eb4e6a0)
-   Revert interactive Table column sizing changes



# 24.3.0 (2022-03-09)

### Bug Fixes

-   **SCP-49296:** map visual snapshots flakiness issue (6f9a4b6)

### Features

-   **SCP-33203:** Add interactive table column width adjustments (fab7b06)
-   **SCP-38937:** add matchvalue editor to viz editor configs (0c1540f)
-   **SCP-46972:** add platform Map V0 (6f8b067)
-   **SCP-48432:** generate three-themed snapshots for maps (7ee9aca)
-   **SCP-48502:** Implement Bubble layer - geostats commands for Map(9e501cf)
-   **SCP-48602:** add new data selector frameWithoutSeriesNames (9eb7e81)
-   **SCP-48822:** Implement Marker layer for Map (26e616c)
-   **SCP-48823:** Add tooltips for Marker and Bubbles in Map (12680c6)
-   **SCP-49837:** enable edit mode interactions for map (64be2c0)
-   **SCP-49855:** add matchvalue editor to table viz (90a9933)
-   **SCP-50012:** maps editing ui layer type (a215806)
-   **SCP-50061:** Update resizing for marker layer in Map (62b2840)
-   **SCP-50147:** map editing ui - data formatting (ef55199)
-   **SCP-50159:** Add count field to Bubble tooltip in Map (8e7da6c)
-   **SCP-50452:** add seriesColors option for Marker in Map (876b967)



# 24.2.0 (2022-01-27)

### Features

-   **SCP-48671:** add table column time formatting (9067a6c)



# 24.1.0 (2021-12-20)

### Bug Fixes

-   read timezone context properly in Charting.tsx (c6a2607)
-   **SCP-47750:** "Options" page is not available (af25ebb)
-   corrected annotations in initialRequestParams (b6b1a3c)

### Features

-   **SCP-44448:** link graph selected node text color (e33015f)



# 24.0.0 (2021-11-30)

### Bug Fixes

-   **SCP-42798:** address splunk-charting option update issue (8495453)
-   **SCP-44899:** update link graph event payload (9d7eb63)
-   **SCP-44950:** rename pie chart option seriesColorsByValue to seriesColorsByField (3c601da)
-   **SCP-45647:** update README that is exposed on public npm (973a6f2)
-   **SCP-45888:** fix link graph freezes (32a7177)
-   **SCP-45926:** fix link graph headings (2113969)
-   **SCP-46119:** switch margin to padding for Markdown to fill background (1650d2b)
-   **SCP-46551:** fix typeError in choroplethSvg migration script (f8ea3cd)
-   **SCP-47152:** add all available visualizations to mobile dsl evaluator (0743a12)
-   fix option rename in singleValue migration script (c7fb707)
-   correct defaults for fillerGauge conversion (d7a11fc)

### Features

-   **SCP-31973:** add singleValueRadial maxValue option (5bf22b6)
-   **SCP-34854:** update singleValueRadial options (eebff37)
-   **SCP-42859:** add rectangle migration script (09ca4ef)
-   **SCP-42860:** add ellipse migration script (cf43db2)
-   **SCP-43559:** add migration script for image visualization (40bc9c3)
-   **SCP-43560:** add migration script to convert viz.markdown to splunk.markdown (326b1cf)
-   **SCP-43797:** add migration script for viz.punchcard to splunk.punchcard (4233844)
-   **SCP-43798:** add migration script for fillerGauge (30c9ca2)
-   **SCP-43799:** add markerGauge conversion script (b828771)
-   **SCP-44564:** add migration script for singleValueRadial (40ac861)
-   **SCP-44566:** add migration script for singleValue (2e26c8a)
-   **SCP-44567:** add singleValueIcon migration script (f243bbf)
-   **SCP-44568:** add table migration script (6036120)
-   **SCP-44569:** add choroplethSvg migration script (17612e2)
-   **SCP-44898:** update singleValueRadial editing ui (f2dd56b)
-   **SCP-45193:** remove markdown upper spacing on first-line headers (f6156de)
-   **SCP-45626:** update singleValueRadial colors (9a8b58b)
-   **SCP-45631:** add migration script for rangeValue formatter (bb30436)
-   **SCP-45632:** add migration script for matchValue formatter (c40101d)
-   **SCP-45633:** add migration script for gradient formatter (425c330)
-   **SCP-45655:** update UX of single value radial component (e016b6c)
-   **SCP-45958:** add static gaugeColor editing ui for fillergauge (403c4dc)
-   **SCP-46124:** add migration script to convert viz.text to splunk.markdown (a3b2be4)
-   **SCP-46530:** add new data selector seriesByTypes and docs (cce0348)

### BREAKING CHANGES

-   **SCP-31973, SCP-34854:** update the options of singleValueRadial for `majorValue`, `trendValue`, `trendIndicatorPosition` (removed), `majorValueField`, and `maxValue` (added). See the doc for the updated option types, names, and default values
-   **SCP-44899:** update link graph event payload `field` to `name` and added `row.<fieldname>.value` for event payload consistency across viz components
-   **SCP-44950:** rename pie chart option `seriesColorsByValue` to `seriesColorsByField`
-   **SCP-45626:** update singleValueRadial colors including `majorColor`, `trendColor`, `radialStrokeColor`, `radialBackgroundColor`, and `backgroundColor`
-   **SCP-45655:** update UX (radial shape, padding/margins, alignments) of singleValueRadial component, no functionality change
-   **SCP-45958:** update default gaugeColor value to `#7B56DB` in fillerGauge



# 23.5.0 (2021-10-14)

### Bug Fixes

-   **SCP-43430:** address Table onCellClick callback issue (cc2759e)
-   **SCP-45644:** add background color editor to Marker Gauge (3792049)

### Features

-   **SCP-41346:** add fontcolor option for markdown (4a96835)
-   **SCP-41348:** add background color option and editor for Markdown (d4b0cae)



## 23.4.1 (2021-10-11)

### Bug Fixes

-   **SCP-44945:** fix SingleValue trend logic for negative values (8a47d4f)
-   **SCP-45010:** fix rectangle radius option UI (44c55a5)
-   **SCP-45809:** fix label option name in the UI for FillerGauge and MarkerGauge (2775807)



# 23.4.0 (2021-09-27)

### Bug Fixes

-   link graph optimizations (dfbf33b)
-   **SCP-32464:** hide internal fields in UDF table visualizations (a10957d)
-   **SCP-43522:** sv trend shows 0% when calculation is not possible (db60693)
-   **SCP-43953:** fix typeError when field option not exist in datasource (c28e44d)
-   **SCP-44165:** fix parallel coords crash w/ array values (7b41808)
-   **SCP-44172:** viz drilldown handler fix for mode change (4280123)
-   **SCP-44190:** add fieldByTypes to Sankey linkvalues editor config (3198706)
-   move json-schema to devDependencies (c6dd133)
-   **SCP-44166:** PC showing numeric data as categorical axes (6bde0d7)
-   **SCP-44172:** remove view mode from eventHandler assign check (392d992)
-   **SCP-44197:** splunk.image does not support drilldown (6554d98)
-   **SCP-44231:** limit merging default options to objects and primitives (f21ccf8)
-   **SCP-44238:** remove "too small to render" for SingleValue/Icon/Radial (559b900)
-   **SCP-44852:** fix Link Graph and Table editors negative values (fbc3253)
-   **SCP-44918:** name of option corrected for Spacing (dffbd11)

### Features

-   **SCP-37338, SCP-37339:** add filler gauge component (637b06c)
-   **SCP-37340:** expose editing ui for filler gauge (b5b7481)
-   **SCP-37341:** add filler gauge surface documentation (4dfa711)
-   **SCP-42861:** scatter chart migration script (6364c37)
-   **SCP-42862:** bubble chart migration script (fa3eeeb)
-   **SCP-43179:** add editing ui for markergauge (3312388)



# 23.3.0 (2021-09-01)

### Bug Fixes

-   **SCP-44294:** fixing enum type for bubbleSizeMethod (13edc12)
-   **SCP-44351:** accept more than 2 columns for pie datasources (dea9b20)

### Features

-   **SCP-37330, SCP-43174:** create Marker Gauge component and add all options (95588e0)
-   **SCP-37347:** add axes and label and color options for punchcard (14df131)
-   **SCP-37348:** add bubble formatting options for punchcard (81cd1c0)
-   **SCP-37349:** expose editing UI for punchcard (a2556df)



# 23.2.0 (2021-08-23)

### Bug Fixes

-   **SCP-43603:** Miscellaneous fixes and cleanups for Sankey (2c2a11a)
-   **SCP-44005:** fix css injection Sankey (4d1e179a)

### Features

-   **SCP-37346:** create punchcard component (ccd6f9d)
-   **SCP-40717:** add editor UI for bg color option Parallel Coordinates (e6cbbad)
-   **SCP-41626:** create platform link graph with skeleton config (34d44c4)
-   **SCP-42093:** splunk.area migration script (7790d4f)
-   **SCP-42114:** splunk.line migration script (79c709d)
-   **SCP-42115:** splunk.pie migration script (3d3e06f)
-   **SCP-42450:** add editor ui for Sankey link colors (a2dd349)
-   **SCP-43172:** expose options for linkColors and colorMode in Sankey (3564e69)
-   **SCP-43760:** update data processing and smallest dimension of Parallel Coordinates (67c0ffa)
-   **SCP-43788:** add editor ui for Parallel Coordinates (1d1dbf7)



# 23.1.0 (2021-08-17)

### Features

-   **SCP-41585:** sankey edit UI backgroundcolor (3cdf25e)



# 23.0.0 (2021-08-12)

### Bug Fixes

-   **SCP-34440:** fixes single value borders on safari (bd251e1)
-   **SCP-38767:** use hasEventHandlers flag check before calling onEventTrigger (0105355)
-   **SCP-42667:** add backgroundColor color picker to editing UI (3cdcd09)
-   **SCP-42679:** support splunk.pie fields with numeric data (3fae41b)
-   **SCP-43213:** rename item in dynamic elements (3b6fb45)
-   **SCP-43713:** address Column update error in Safari (b30d061)

### Features

-   **MIGRATION:** add x, y, y2 options to Column & Bar (914b04b)
-   **O11Y:** add showTooltip to Column (c6577fb)
-   **SCP-37306, SCP-37307:** create Scatter chart component, add axis title & label formatting options (29aacdb)
-   **SCP-37314:** add bubble chart component (cf0a7c4)
-   **SCP-37378:** add image component (c42755c)
-   **SCP-37378:** add image component (c42755c)
-   **SCP-40555:** create parallel coordinates component (85d029a)
-   **SCP-42951:** Create platform sankey diagram component with skeleton config (6808068)
-   **SCP-40714:** introduce dynamic options evaluator package (1fdbfff)
-   **SCP-41598:** create-pure-link-graph-component (d116dfc)
-   **SCP-41620:** enforce consistent singleValue token structure (fd94ef5)
-   **SCP-42099:** rename `dataName` and `dataValue` to `name` and `value` for `splunk.choroplethsvg` event payload (8af73fdd)
-   **SCP-42100:** use `name2` and `value2` (y-field and y-value) for `name` and `value` for charting-viz event payload keys, and remove `name2` and `value2` (1cc0bcc2)
-   **SCP-42532:** add showLines and areaOpacity options to area chart (d352baf)
-   **SCP-42575:** Enable categorical data to show on axis and create parallel coordinates platform viz (2fdeee6)
-   **SCP-42891:** update ux to match designs for link graph (b04208f)
-   **SCP-43065:** enforce a flattened event payload for the `row` key for `splunk.table` (6dc71a7b)
-   **SCP-43382:** flatten 'row' payload for charting-based visualizations (fbf45c2)
-   **SCP-43553:** remove rowValues from table event payload (29eb583)

### BREAKING CHANGES

-   **SCP-43553:** `rowValues` is removed from the `splunk.table` event payload to avoid duplication with `row.<fieldname>.value`
-   **SCP-43382:** The `rowContext` key in event payloads for charting-based platform visualizations (e.g. area, bar, column, line, pie) is renamed to `row` and the payload is also flattened. For example, `{ rowContext: { row._time: "1525310147.000", row.count "10" } }` will now be `{ row._time: "1525310147.000", row.count: "10" } }`
-   **SCP-43065:** `splunk.table` has a flattened event payload for the `row` key. `{ row: { [columnName]: { value: "2019-01-06" }, [columnName2]: { value: "2019-01-07" } } }` is now flattened to `{ "row.<columnName>.value": "2019-01-06", "row.<columnName2>.value": "2019-01-07" }`
-   **SCP-42679:** The `splunk.pie` defaults for `label` and `value` have been changed from seriesByType("string") and seriesByType("number") to seriesByIndex(0) and seriesByIndex(1) respectively.
-   **SCP-42100:** The event payload keys `name2` and `value2` have been removed for Area, Bar, Column, Line, and Pie. `name` and `value` now contain values that correspond to the y-field and y-value for a chart (or label and value for Pie).
-   **SCP-42099:** The event payload keys `dataName` and `dataValue` for `splunk.choroplethsvg` have been renamed to `name` and `value`
-   **SCP-41620:** The `majorValue` key for `splunk.singlevalue`, `splunk.singlevalueicon`, and `splunk.singlevalueradial` has been changed to `value`, and an additional `name` field (which corresponds to the datasource column name) has been added. For example, `{ majorValue: 1320, trendValue: 390 }` will now be `{ name: <columnName>, value: 1320, trendValue: 390 }`
-   **SCP-38767:** The charting events point.click and legend.click event handlers were triggered earlier without relying on hasEventHandlers flag. With this change the point.click and legend.click event handlers will be triggered only if hasEventHandlers flag is set to true. This applies for all charting-based visualizations. Consuming applications should set hasEventHandler flag to true in order for the charting event handler onEventHandler to get activated in the view mode.

See the MIGRATION.md for more details



# 22.3.0 (2021-07-12)

### Bug Fixes

-   **SCP-41158:** provide click interaction feedback for table (49a9c43)
-   fix event test viz for bar, area, remove range.select from bar (96b8199)

### Features

-   **SCP-37362, SCP-37363:** create rectangle component and add options (fc16e9d)
-   **SCP-37364:** expose editing UI for rectangle (eb86abe)
-   **SCP-37365:** rectangle surface documentation (8ebb6fb)
-   **SCP-37370:** add ellipse component and formatting options (7e4d1ed)
-   **SCP-37372:** expose editing UI for ellipse (a6375f7)
-   **SCP-37373:** add surface documentation for ellipse (446501a)
-   **SCP-42097:** consistent table token structure (ef25b33)



# 22.2.0 (2021-06-25)

### Bug Fixes

-   **SCP-38928:** long tooltip cut off issue (d15188d)
-   **SCP-41622:** correct dataValuesDisplay 'off' mapping for Column (e5872ef)
-   schema keywords should be copied over when enhancing with dynamic options (7740868)
-   **SCP-40715:** table with sparkline returns bunch of error in console (c25e02f)
-   **SCP-40716:** add default table header bg color and padding, fix width (41a1cc3)
-   **SCP-40918:** fix inverted legend truncation editor UI (90a8b0f)

### Features

-   **SCP-37291:** add axis title and label formatting options for bar chart (3753a1c)
-   **SCP-37292:** expose editing ui for bar chart (8a56eef)
-   **SCP-37295:** add axis grid formatting options for bar chart (c07c548)
-   **SCP-37297:** add content and legend formatting options for Bar (6878d6a)
-   **SCP-37297:** add content and legend formatting options for bar chart (ee6da06)
-   **SCP-37299:** add axis title and label formatting options to area chart (f0b5585)
-   **SCP-37300:** add grid formatting options to area chart (bbecf91)
-   **SCP-37301:** add content legend formatting options to area chart (22b1970)
-   **SCP-37302:** expose editing ui for area chart (9450e1c)
-   **SCP-37322:** add pie chart component (2e3fe79)
-   **SCP-37323:** add formatting options to pie chart (34f1a0a)
-   **SCP-37324:** expose editor config for pie chart (a581518)
-   **SCP-37354:** create markdown component (2a9a956)
-   **SCP-37356:** expose editing ui for markdown component (91007d8)
-   **SCP-40485:** Column chart add xaxislinevisibility yaxislinevisibility and y2axislinevisibility (8fa1a63)
-   **SCP-40488:** add axis line visibility options for line chart (bb46f8c)
-   **SCP-40495:** Column chart update column.test.jsx to column.test.tsx (5b6efa8)
-   **SCP-41101:** add axes line visibility options for bar chart (23c33f5)
-   **SCP-41102:** Area chart add xaxislinevisibility yaxislinevisibility and y2axislinevisibility (0fdd17a)
-   **SCP-41527:** add background color editor option to editing UI (85baf97)
-   **SCP-41597:** add showDonutHole option for pie chart (2e7e913)



## 22.1.1 (2021-05-28)

### Bug Fixes

-   **SCP-40632:** fix for inconsistency with title of visualization in doc (2da1e9b)
-   **SCP-40668:** min and Max added to 'xAxisMaxLabelParts' option (fab4ef2)
-   **SCP-40712:** fix enterprise dark single value stroke color calculation (7488e91)



# 22.1.0 (2021-05-25)

### Bug Fixes

-   **SCP-37288:** fix console error for docs (34cd356)
-   **SCP-38760:** table cell size expands unexpectedly with sparklines (21e3378)
-   resolve react-ui to root node_modules for webpack.docs.config.js (d435ce7)

### Features

-   **SCP-37265, SCP-37264, SCP-37277, SCP-38047:** add x-axis label formatting, title visibility, content formatting, axis formatting options to column chart (77d6028)
-   **SCP-37266:** Column chart y axis label formatting (0bce980)
-   **SCP-37274:** Column chart y2 axis label formatting (c65f3dc)
-   **SCP-37276:** Content color formatting part 1 v2 (44c5253)
-   **SCP-37283:** add X-Axis label formatting options (60ab62f)
-   **SCP-37284:** add Y axis label formatting options (572de57)
-   **SCP-37285:** add Y2 Axis label formatting options (f1d744a)
-   **SCP-37286:** add line axis grid options (01c4ab7)
-   **SCP-37287:** add axis formatting options to line chart (47e5122)
-   **SCP-37288:** add line viz legend formatting options (24578a1)
-   **SCP-38045:** Column chart axis grid formatting (a3ae46c)
-   **SCP-38048:** Column chart legend formatting (6037dc1)
-   **SCP-38700:** Column chart content formatting part 2 (8209297)
-   **SCP-38702:** add line chart content formatting options (aec3301)
-   **SCP-38703:** add content formatting options for line chart (813c15c)
-   **SCP-38936:** add line viz surface documentation (18ec35e)
-   **SCP-39649:** add line markerDisplay option (622c8a6)
-   **SCP-39904:** add editorUI config for markdown (827e6b0)
-   **SCP-40338:** Column chart create and expose editorConfig entry (1a72d4e)
-   **SCP-40341:** create and expose editorConfig (99c637f)
-   **SCP-40379:** updates categorical colors for @splunk/visualizations (5fb7983)
-   new column (ec80b49)



## 22.0.2 (2021-05-02)

### Bug Fixes

-   **DEPS:** address dependency issues in visualizations package (21784c3)
-   incorrect row background colors for table in enterprise dark (f79113b)
-   **SCP-39079:** correction of textOverflow type (2c2e674)



## 22.0.1 (2021-04-07)

### Bug Fixes

-   **SCP-38419:** allow table to navigate back to first page (1aa8c51)
-   upgrade SUI to v4.0.3 due to color picker bug (8893ee6b)



# 22.0.0 (2021-03-31)

### Bug Fixes

-   **SCP-37179:** remove `trendDisplayMode` and `showTrendIndicator` in singleValueUtils and SingleValueRadial (ce8254f)

### Features

-   SUI 4.0 compatibility (49a3c2b)
-   **SCP-36869:** update Single Value sparklineAreaColor default (49f56af)
-   **SCP-36902:** implements prop sanitizer for visualization package (829be23)
-   **SCP-37197:** implements column width and truncation (ef99452)
-   **SCP-37273:** provides seriesByPrioritizedTypes for DataFrame (935d589)
-   **SCP-37488:** visualization package now exports config/utils files (e437557)

### BREAKING CHANGES

-   -   @splunk/dashboard-visualizations, @splunk/react-visualizations, @splunk/visualization-editors, and @splunk/visualizations no longer export their own themes via themeRegistry; all theming is consolidated within styled-components or self-contained in visualizations themselves using @splunk/themes utils and obtains theming information from `<SplunkThemeProvider>`

*   various theming changes to visualization background colors and viz theming colors
*   if no `<SplunkThemeProvider>` is specified, all visualizations and editors will default to using prisma dark theming
*   see MIGRATION.md and updated v22.0.0 CHANGELOG entry for more detailed list of breaking changes

-   **SCP-36869:** This modifies the default behavior of sparklineAreaColor to be in sync with the sparklineStrokeColor
option
-   **SCP-37179:** SingleValueRadial options updates: 1. deprecated `trendDisplayMode` and `showTrendIndicator`. 2. added `trendDisplay` option with "off, absolute, percentage".



## 21.1.2 (2021-03-02)

### Bug Fixes

-   proper default export for PlatformTable (f6da13d)



## 21.1.1 (2021-02-23)

### Bug Fixes

-   **SCP-34886:** triggers onRequestParamsChange on count prop change (47fe030)
-   **SCP-36010:** Icon in SVI should be positioned and scaled correctly when color is applied. (d0cdffd)
-   **SCP-36029:** temporarily hide unsupported MatchValue from editors (a659c87)
-   **SCP-36282:** refactor withDashboards to use hook rules (300d4cb)
-   **SCP-36770:** intermittent DSL change should not crash viz (300d4cb)
-   **SCP-36669:** unset dataSource when data binding does not exist (e401c0d)
-   **SCP-36931:** return default theme font color for table if the background is transparent (b573b96)
-   **VIZ:** add @splunk/visualization-context peer dep (b23199e)



# 21.1.0 (2021-02-10)

### Bug Fixes

-   **SCP-36030:** update handlers in dynamic color editor (fc230cb)
-   **VIZ:** re-evaluate options on theme change (86c2e69)

### Features

-   **SCP-32757:** column-specific formatter editor for table (55bcf19)
-   **SCP-33204:** graceful handling of invalid Editor UI states for Dynamic Color Editor (3a8ef01)
-   **SCP-34063:** implements background color and row color editors (62a609c)
-   **SCP-34973:** table column coloring editor (ddcca6c)
-   **SCP-36110:** use datasource api in ColumnSelectionEditor (292715e)



# 21.0.0 (2021-02-02)

### Bug Fixes

-   **SCP-35330:** Add a cover layer on top of viz if the mode is `edit` to smooth the mouse interaction on UDF (cbf67d8)
-   **SCP-35720:** standardize single value delta/trend option naming (e55297f)
-   **SCP-36089:** update choropleth areaIds default (c7a192c)

### Features

-   **SCP-21397:** build dynamic editor for `splunk.choropleth.svg`. (82ae19e)

### BREAKING CHANGES

-   **SCP-35720:** update SingleValue, SingleValueIcon and SingleValueRadial option naming from delta to trend
-   **SCP-36089:** update choropleth areadIds default to use seriesByType("string") formatter
-   **SCP-21397:** change the default of `areaColors` option to `> areaValues|rangeValue(areaColorsRangeConfig)` with `rangeValue` formatter.



# 20.7.0 (2021-01-27)

### Bug Fixes

-   **SCP-26227:** add themed default sparklineStrokeColor (4046408)
-   **SCP-35067:** add disabled functionality to editor (85af934)
-   **SCP-35090:** add events to single value radial (d03e949)

### Features

-   **SCP-35337:** add background to Placeholder for splunk visualizations (f12ac8e)

### Performance Improvements

-   **SCP-35770:** memoize evaluated dynamic options (d43a5a1)



## 20.6.1 (2021-01-13)

### Bug Fixes

-   change the viz keys for all viz (611e908)
-   rename editor context keys to avoid default context merging (67cc27e)



# 20.6.0 (2021-01-12)

### Bug Fixes

-   **SCP-35126:** use undefined for default DSL delta value (4adf210)
-   **SCP-35192:** adds default backgound color for table (898c6a6)

### Features

-   **SCP-32688:** add ColumnSelectorEditor (944cf32)
-   **SCP-33503:** Implement onAreaClick event for Choropleth SVG (8f30951)
-   **SCP-34876:** implements dimension support for table (8db2e26)
-   **SCP-34878:** implements cell click for table viz (067803d)
-   **SCP-35144:** integrate range value editor with SV/SVI flyout (3a109ba)
-   **SCP-35318:** supports mixed type series for splunk single value and single value icon with dynamic options (38d1d12)
-   **SCP-35343:** adds placeholder for Table and SVR (803ff4a)



# 20.5.0 (2020-12-11)

### Bug Fixes

-   **SCP-34885:** fixes crash when onRequestParamsChange is not specified (f79abb9)
-   change default value for majorValue and deltaValue of SV and SVI with seriesByType('number') (8933186)
-   dont return onComputedProps useeffect hook in HOC (430a3f9)
-   **SCP-34975:** fixes table not displaying 0s (1d4b4c2)

### Features

-   **SCP-32525:** implements basic table editor (5bf4559)
-   **SCP-32679:** add dynamic color editor part 1 (5570288)



# 20.4.0 (2020-12-05)

### Bug Fixes

-   **SCP-34500:** change oneOf to anyOf in enhanced configSchema (81100ab)
-   change oneOf to anyOf in docs (f5b57a1)

### Features

-   **SCP-34583:** add category to VizConfig (47e21cf)
-   **SCP-34711:** implements table sparkline and multivalue fields (4aeeb25)
-   **SCP-32524:** implements table column alignment based on data type and type formatting (092ca47)



# 20.3.0 (2020-11-20)

### Bug Fixes

-   set default height and width to 250 and "100%" for platform viz (cc9c8ae)

### Features

-   **SCP_33100:** add placeholder support (07e669d)
-   **SCP-31679:** implements table wide options and column overrides (73dabf3)
-   implements sorting, paging, backgroundColor and count for table (708a8ae)
-   move default theme colors to computeVizProps (c8d04db)
-   **SCP-32358:** add themes to SingleValueIcon DO (841d28b)
-   **SCP-32679:** add dynamic color editor part 1 (be04271)
-   **SCP-33634:** dsl editor theme support (1f58709)
-   **SCP-34360:** make platform viz independent (21aca36)



# 20.2.0 (2020-11-12)

### Bug Fixes

-   **SCP-33646:** set evaluatedOptions to be an empty object initially (203074a)
-   **SCP-33829:** allow custom event handlers for singlevalue (5a38cb3)

### Features

-   **SCP-24455:** static editor for platform single value icon (1dc6911)
-   **SCP-31615:** implements splunk table v1 (7469ef1)
-   **SCP-32278:** add DSL theme support to SingleValue (ea87041)
-   **SCP-32686:** editor preset selector component (28d5516)
-   **SCP-33095:** publish @splunk/visualizations and @splunk/visualization-encoding package (c50aafe)
-   **SCP-33701:** update editor for sv and svi (e7e4f39)
-   **SCP-33704:** add SV and SVI events for consolidated viz docs (ecfcf91)



# 20.1.0 (2020-10-21)

### Bug Fixes

-   returns N/A if majorValue is null (85a39b0)

### Features

-   **SCP-24446:** build static editor for `splunk.singlevalue` (cc6d9b9)
-   **SCP-31904:** initial choro platform viz docs and multiMap formatter (57e3ff3)
-   **SCP-32280:** deprecate showIcon for single value icon (cd42ced)
-   **SCP-32870:** add RemoteIcon support for Single Value Icon (0e7517c)
-   **SCP-32883:** add separate pointsByIndex and pointByIndex selectors (ef7b325)
-   **VIZ:** add onComputedProps callback to platform visualizations (94d58d2)



# 20.0.0 (2020-10-07)

### Bug Fixes

-   add string as accepted proptype for width and height (9f13409)
-   addresses security vulnerabilties related to color options (824b096)
-   always use iconColor option for svg icon (53b17bf)

### Features

-   **SCP-20317:** remove SV color-related options support (d3b95d2)
-   **SCP-24452:** Support dynamic options for Single Value Radial (fb9c43e)
-   **SCP-29196:** ChoroplethSvg with Dynamic options (fd76dad)
-   **SCP-29502:** Build Single Values Icon with Dynamic Options, and add iconColor, majorColor and deltaColor options to Single Value Icon. (831762e)
-   **SCP-31542:** initial docs config for consolidated viz package (ea3ee5a)
-   **SCP-31710:** update options schema to support dynamic options DSL (eb09831)
-   **STORYBOOK-DOCS:** initial storybook docs (dab7a94)

### BREAKING CHANGES

-   **SCP-20317:** Dropped support for SingleValue colorBy, trendColorInterpretation, colorMode options



# 19.1.0 (2020-09-05)

**Note:** Version bump only for package @splunk/visualizations



# 19.0.0 (2020-08-28)

### Bug Fixes

-   fix packages dependency in react-viz (4b9e825)

### Features

-   **SCP-29193:** Support dynamic options for Single Value (6cb237d)
-   **SCP-29793:** allow getField method in dynamic options to return fieldname (a34ac08)



## 18.2.1 (2020-07-30)

**Note:** Version bump only for package @splunk/visualizations



# 18.2.0 (2020-07-29)

### Features

-   **DYNAMIC OPTIONS:** Add grammar, AST, parser, and evaluator for dynamic options (fc92467f)
