/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Ellipse/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport4 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport5 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport6 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport7 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}
function hasCompatibleContexts(vizContext, presetContext) {
  const presetContextKeys = Object.keys(presetContext);
  return presetContextKeys.every(
    (contextKey) => presetContext[contextKey] === void 0 && vizContext[contextKey] === void 0 || presetContext[contextKey] !== void 0 && vizContext[contextKey] !== void 0
  );
}
function hasCompatibleOptions(vizOptions, presetOptions) {
  const presetOptionKeys = Object.keys(presetOptions);
  return presetOptionKeys.every(
    (optionKey) => (0, configUtils_exports.isDynamicOption)(presetOptions[optionKey]) === (0, configUtils_exports.isDynamicOption)(vizOptions[optionKey])
  );
}
function getInitialPreset(vizContext, vizOptions, presets2) {
  return presets2.find((preset) => {
    const presetContext = (0, lodash_exports.get)(preset, ["value", "context"], {});
    const presetOptions = (0, lodash_exports.get)(preset, ["value", "options"], {});
    const presetContextKeys = Object.keys(presetContext);
    const presetOptionKeys = Object.keys(presetOptions);
    if (presetContextKeys.length === 0 || presetOptionKeys.length === 0) return false;
    return hasCompatibleContexts(vizContext, presetContext) && hasCompatibleOptions(vizOptions, presetOptions);
  });
}

// src/common/editorConfig/DynamicFillColorEditor.ts
var getDynamicFillColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Fill"),
  option: "fillColor",
  context: "fillColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.fillColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: fill"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          fillDataValue: defaultContext2.fillColorConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          fillDataValue: defaultContext2.fillColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Fill"),
        value: "fillDataValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/DynamicStrokeColorEditor.ts
var getDynamicStrokeColorEditor = ({ defaultContext: defaultContext2, defaultPalettesConfig: defaultPalettesConfig2 }) => ({
  label: (0, i18n_exports._)("Stroke"),
  option: "strokeColor",
  context: "strokeColorEditorConfig",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options.strokeColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic coloring: stroke"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        defaults: {
          strokeDataValue: defaultContext2.strokeColorConfig
        }
      },
      {
        label: (0, i18n_exports._)("Matches"),
        value: "matchValue",
        defaults: {
          strokeDataValue: defaultContext2.strokeColorMatchConfig
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Stroke"),
        value: "strokeDataValue"
      }
    ],
    defaultPalettesConfig: defaultPalettesConfig2
  }
});

// src/common/editorConfig/StaticFillColorEditor.ts
var StaticFillColorEditor = {
  label: (0, i18n_exports._)("Fill"),
  option: "fillColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.fillColor)
};
var StaticFillColorEditor_default = StaticFillColorEditor;

// src/common/editorConfig/StaticStrokeColorEditor.ts
var StaticStrokeColorEditor = {
  label: (0, i18n_exports._)("Stroke"),
  option: "strokeColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options.strokeColor)
};
var StaticStrokeColorEditor_default = StaticStrokeColorEditor;

// src/Ellipse/config.ts
var dataContract = {
  requiredDataSources: [],
  optionalDataSources: [
    {
      name: "primary",
      description: "DataSource that powers the visualization"
    }
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {
  fillColorConfig: [
    {
      from: 100,
      value: "#118832"
    },
    {
      from: 80,
      to: 100,
      value: "#669922"
    },
    {
      from: 60,
      to: 80,
      value: "#9D9F0D"
    },
    {
      from: 40,
      to: 60,
      value: "#CBA700"
    },
    {
      from: 20,
      to: 40,
      value: "#D97A0D"
    },
    {
      from: 0,
      to: 20,
      value: "#D94E17"
    },
    {
      to: 0,
      value: "#D41F1F"
    }
  ],
  strokeColorConfig: [
    {
      from: 100,
      value: "#118832"
    },
    {
      from: 80,
      to: 100,
      value: "#669922"
    },
    {
      from: 60,
      to: 80,
      value: "#9D9F0D"
    },
    {
      from: 40,
      to: 60,
      value: "#CBA700"
    },
    {
      from: 20,
      to: 40,
      value: "#D97A0D"
    },
    {
      from: 0,
      to: 20,
      value: "#D94E17"
    },
    {
      to: 0,
      value: "#D41F1F"
    }
  ],
  fillColorMatchConfig: [{ match: "", value: "#5C33FF" }],
  strokeColorMatchConfig: [{ match: "", value: "#5C33FF" }]
};
var themes = {
  defaultFillColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.gray25(props),
      light: variables_default.gray80(props)
    },
    prisma: variables_default.backgroundColorSidebar(props)
  })(props),
  defaultStrokeColor: (props) => pick_default({
    enterprise: {
      dark: variables_default.gray80(props),
      light: variables_default.gray30(props)
    },
    prisma: variables_default.neutral500(props)
  })(props)
};
var basePresetContext = {
  fillColorEditorConfig: void 0,
  strokeColorEditorConfig: void 0
};
var basePresetOptions = {
  fillColor: void 0,
  strokeColor: void 0
};
var presets = [
  {
    // dummy context variables to allow for resetting of unused context states
    label: (0, i18n_exports._)("None"),
    name: "ellipse.none",
    value: {
      context: __spreadValues({}, basePresetContext),
      options: __spreadValues({}, basePresetOptions)
    }
  },
  {
    label: (0, i18n_exports._)("Fill"),
    name: "ellipse.fill",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        fillDataValue: '> primary | seriesByType("number") | lastPoint()',
        fillColorEditorConfig: defaultContext.fillColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        fillColor: "> fillDataValue | rangeValue(fillColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Stroke"),
    name: "ellipse.stroke",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        strokeDataValue: '> primary | seriesByType("number") | lastPoint()',
        strokeColorEditorConfig: defaultContext.strokeColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        strokeColor: "> strokeDataValue | rangeValue(strokeColorEditorConfig)"
      })
    }
  },
  {
    label: (0, i18n_exports._)("Fill and Stroke"),
    name: "ellipse.fillAndStroke",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        fillDataValue: '> primary | seriesByType("number") | lastPoint()',
        strokeDataValue: '> primary | seriesByType("number") | lastPoint()',
        fillColorEditorConfig: defaultContext.fillColorConfig,
        strokeColorEditorConfig: defaultContext.strokeColorConfig
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        fillColor: "> fillDataValue | rangeValue(fillColorEditorConfig)",
        strokeColor: "> strokeDataValue | rangeValue(strokeColorEditorConfig)"
      })
    }
  }
];
var editorConfig = [
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Dynamic elements"),
          key: "presetSelector",
          editor: "editor.presetSelector",
          editorProps: {
            presets,
            value: ({ context, options }) => {
              const initialPreset = getInitialPreset(context, options, presets);
              return initialPreset && initialPreset.label || null;
            }
          }
        }
      ],
      [
        __spreadProps(__spreadValues({}, StaticFillColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicFillColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        __spreadProps(__spreadValues({}, StaticStrokeColorEditor_default), {
          editorProps: {
            themes
          }
        })
      ],
      [getDynamicStrokeColorEditor({ defaultContext, defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig })],
      [
        {
          label: (0, i18n_exports._)("Fill opacity (%)"),
          option: "fillOpacity",
          editor: "editor.percent",
          editorProps: {
            min: 0
          }
        },
        {
          label: (0, i18n_exports._)("Stroke opacity (%)"),
          option: "strokeOpacity",
          editor: "editor.percent",
          editorProps: {
            min: 0
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Stroke width"),
          option: "strokeWidth",
          editor: "editor.number",
          editorProps: {
            min: 0
          }
        },
        {
          label: (0, i18n_exports._)("Stroke dash style"),
          option: "strokeDashStyle",
          editor: "editor.number",
          editorProps: {
            min: 0
          }
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.ellipse",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Ellipse"),
  category: "Shapes" /* SHAPES */,
  /**
   * viz icon
   */
  icon: null,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.ellipseOptionsSchema,
  editorConfig,
  events: {
    "ellipse.click": {
      description: "triggered when user clicks ellipse",
      payloadKeys: ["strokeColor", "fillColor"]
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */],
  themes
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=Ellipse.config.js.map
