/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/Markdown/config.ts
var config_exports = {};
__export(config_exports, {
  default: () => config_default
});
module.exports = __toCommonJS(config_exports);

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport2 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport4 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport5 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config2) => {
      return __spreadProps(__spreadValues({}, config2), { open: config2.open || false });
    }
  );
  return enhancedConfig;
}

// src/common/editorConfig/BackgroundColor.ts
var background = ({
  label,
  themes: themes2,
  labelPosition
}) => [
  {
    label: (0, i18n_exports._)(label || "Background color"),
    option: "backgroundColor",
    editor: "editor.color",
    editorProps: {
      labelPosition: labelPosition || "top",
      themes: themes2
    }
  }
];
var BackgroundColor_default = background;

// src/Markdown/config.ts
var FONT_OPTIONS = /* @__PURE__ */ new Set(["extraSmall", "small", "default", "large", "extraLarge"]);
var dataContract = {
  requiredDataSources: [],
  optionalDataSources: [
    // Note: SCP-14090 disable ui for optional datasources. We may need to add it back later
    // {
    //     name: 'annotation',
    //     description: 'DataSource that populate event annotations',
    // },
  ],
  initialRequestParams: {
    primary: { offset: 0, count: 1e4 }
  }
};
var size = {
  initialWidth: 300,
  initialHeight: 300
};
var defaultContext = {};
var themes = {
  defaultFontColor: (props) => (0, themes_exports.pick)({
    enterprise: {
      dark: themes_exports.variables.textColor(props),
      light: themes_exports.variables.textColor(props)
    },
    prisma: themes_exports.variables.contentColorDefault(props)
  })(props)
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Font"),
          option: "fontColor",
          editor: "editor.color",
          editorProps: {
            labelPosition: "top",
            themes
          }
        },
        ...BackgroundColor_default({ label: "Background", themes })
      ],
      [
        {
          label: (0, i18n_exports._)("Font family"),
          option: "fontFamily",
          editor: "editor.select",
          editorProps: {
            values: [
              { value: "Splunk Platform Sans" },
              { value: "Splunk Data Sans" },
              { value: "Splunk Platform Mono" },
              { value: "Arial" },
              { value: "Helvetica" },
              { value: "Times New Roman" },
              { value: "Comic Sans MS" }
            ]
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Font size"),
          option: "fontSize",
          editor: "editor.select",
          editorProps: {
            values: [
              { label: (0, i18n_exports._)("Extra Small"), value: "extraSmall" },
              { label: (0, i18n_exports._)("Small"), value: "small" },
              { label: (0, i18n_exports._)("Default"), value: "default" },
              { label: (0, i18n_exports._)("Large"), value: "large" },
              { label: (0, i18n_exports._)("Extra Large"), value: "extraLarge" },
              { label: (0, i18n_exports._)("Custom"), value: "custom" }
            ]
          }
        },
        {
          label: (0, i18n_exports._)("Custom font size (px)"),
          option: "customFontSize",
          editor: "editor.number",
          editorProps: {
            min: 0,
            labelPosition: "top"
          },
          showEditor: ({ options }) => options.fontSize && !FONT_OPTIONS.has(options.fontSize)
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Rotation (degrees)"),
          option: "rotation",
          editor: "editor.number",
          editorProps: {
            min: -360,
            max: 360
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Markdown content"),
    open: true,
    layout: [
      [
        {
          label: "",
          option: "markdown",
          editor: "editor.markdown"
        }
      ]
    ]
  }
];
var config = {
  /**
   * unique viz key
   */
  key: "splunk.markdown",
  /**
   * viz name
   */
  name: (0, i18n_exports._)("Markdown"),
  category: "Comparisons" /* COMPARISONS */,
  /**
   * viz icon
   */
  icon: null,
  dataContract,
  size,
  defaultContext,
  optionsSchema: visualization_schemas_exports.markdownOptionsSchema,
  editorConfig,
  events: {
    "markdown.click": {
      description: "triggered when user clicks on markdown area not formatted as a link"
    }
  },
  supports: ["dynamic-options" /* DYNAMIC_OPTIONS */, "events" /* EVENTS */],
  themes
};
var config_default = enhanceConfig(config);
//# sourceMappingURL=Markdown.config.js.map
