/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// src/SparkLine/index.ts
var SparkLine_exports = {};
__export(SparkLine_exports, {
  default: () => SparkLine_default
});
module.exports = __toCommonJS(SparkLine_exports);

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport2 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport3 = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport4 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/react-ui/Popover
var Popover_exports = {};
__export(Popover_exports, {
  default: () => Popover_default
});
var defaultImport5 = __toESM(require("@splunk/react-ui/Popover"));
__reExport(Popover_exports, require("@splunk/react-ui/Popover"));
var Popover_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport6 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport7 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// src/SparkLine/SparkLine.jsx
var StyledSvg = styled_components_default.svg`
    /* For fixing IE11 shows overflow part line issue */
    overflow: hidden;
`;
var StyledTooltip = styled_components_default.div`
    padding: 3px 8px;
    font-size: 12px;
`;
var _SparkLine = class _SparkLine extends react_exports.Component {
  constructor(props, ...rest) {
    super(props, ...rest);
    __publicField(this, "handleCursorMount", (el) => {
      this.setState({
        anchor: el
      });
    });
    this.state = {
      anchor: null,
      currentPointX: null,
      open: false,
      rectArea: null,
      tooltip: null
    };
    this.titleId = (0, id_exports.createDOMID)();
  }
  getMax() {
    const { data, acceptNull, yMax } = this.props;
    const dataMax = () => acceptNull ? (0, lodash_exports.max)(this.fillNull(data)) : (0, lodash_exports.max)(data);
    return yMax !== void 0 ? yMax : dataMax();
  }
  getMin() {
    const { data, acceptNull, yMin } = this.props;
    const dataMin = () => acceptNull ? (0, lodash_exports.min)(this.fillNull(data)) : (0, lodash_exports.min)(data);
    return yMin !== void 0 ? yMin : dataMin();
  }
  /**
   * Gets unit value of x axis.
   * @param {Number} xMargin - margin of x axis.
   * @return {Number} unit value of x axis.
   * @private
   */
  getXUnit(xMargin) {
    const { data, width } = this.props;
    const xUnit = (width - xMargin * 2) / (data.length > 1 ? data.length - 1 : 1);
    return Math.max(0, xUnit);
  }
  /**
   * Gets unit value of y axis.
   * @param {String} yMargin - margin of y axis.
   * @return {Number} unit value of y axis.
   * @private
   */
  getYUnit(yMargin) {
    const { height } = this.props;
    const maxValue = this.getMax();
    const minValue = this.getMin();
    const yUnit = (height - yMargin * 2) / (maxValue - minValue || 2);
    return Math.max(0, yUnit);
  }
  /**
   * Get a list of arrays of points for drawing lines, based on acceptNull property
   * @method getSegmentSets
   * @param {Array} data
   * @param {Array} points
   * @returns {Array} List of datapoint sets used for drawing lines
   */
  getSegmentSets(data, points) {
    const { acceptNull } = this.props;
    const lines = [];
    let currentLine = [];
    data.forEach((p, idx) => {
      if (!acceptNull && (0, lodash_exports.isNull)(p)) {
        if (currentLine.length > 1) {
          lines.push(currentLine);
        }
        currentLine = [];
      } else {
        currentLine.push(points[idx]);
      }
    });
    if (currentLine.length > 1) {
      lines.push(currentLine);
    }
    return lines;
  }
  /**
   * Utility for fill null value with number 0.
   * @private
   */
  fillNull() {
    const { data } = this.props;
    return data.map((value) => value === null ? 0 : value);
  }
  /**
   * Converts data to points in svg
   * @param {Number} xMargin - margin of x axis.
   * @param {Number} yMargin - margin of x axis.
   * @return {Array} points coordination.
   * @private
   */
  dataToPoints(xMargin, yMargin) {
    const { data } = this.props;
    const xUnit = this.getXUnit(xMargin);
    const yUnit = this.getYUnit(yMargin);
    const maxValue = this.getMax();
    const minValue = this.getMin();
    return data.map((val, idx) => ({
      x: idx * xUnit + xMargin,
      y: maxValue === minValue ? yUnit + yMargin : (maxValue - val) * yUnit + yMargin
    })).map((p) => [p.x, p.y]);
  }
  /**
   * Renders rect area for helping figure out which is the nearest point so that
   * render related cursor and tooltip.
   * @param {Array} points - array of points coordination.
   * @param {Number} xMargin - margin of x axis.
   * @return {Array} array of svg rect objects
   * @private
   */
  renderRect(points, xMargin) {
    const { data, height } = this.props;
    const xUnit = this.getXUnit(xMargin);
    return points.map((p, i) => (
      /* eslint-disable react/no-array-index-key */
      /* @__PURE__ */ react_default.createElement(
        "rect",
        {
          key: `${i}_${p[0]}`,
          "data-test": `rect-${i}`,
          x: p[0] - xUnit / 2 <= 0 ? 0 : p[0] - xUnit / 2,
          y: 0,
          width: i === 0 && data.length !== 1 ? xUnit / 2 : xUnit,
          height,
          style: { fillOpacity: 0 },
          onMouseOver: (e) => {
            this.setState({
              open: data[i] !== null,
              rectArea: data[i] === null ? null : e.target,
              tooltip: data[i],
              currentPointX: p[0]
            });
          }
        }
      )
    ));
  }
  // Renders area chart
  renderArea(points) {
    const { data, fillColor, fillOpacity, height, isArea } = this.props;
    if (!isArea || points.length === 0) {
      return null;
    }
    let segments = this.getSegmentSets(data, points);
    segments = segments.map(
      (s) => s.concat([
        [s[s.length - 1][0], height],
        // down to bottom of graph
        [s[0][0], height],
        // over to below first data point
        s[0]
        // up to first data point to close the box
      ])
    );
    return /* @__PURE__ */ react_default.createElement("g", { "data-test": "area" }, segments.map((s) => /* @__PURE__ */ react_default.createElement(
      "polyline",
      {
        key: `area${s.join("")}`,
        points: s.join(" "),
        "data-test": "area-line",
        style: {
          fill: fillColor,
          fillOpacity,
          strokeWidth: "0"
        }
      }
    )));
  }
  renderCursor() {
    const {
      cursorStroke,
      cursorStrokeWidth,
      cursorStrokeLinecap,
      cursorStrokeDasharray,
      height
    } = this.props;
    return this.state.rectArea !== null && /* @__PURE__ */ react_default.createElement(
      "line",
      {
        "data-test": "cursor",
        ref: this.handleCursorMount,
        x1: this.state.currentPointX,
        y1: 0,
        x2: this.state.currentPointX,
        y2: height,
        style: {
          stroke: cursorStroke,
          strokeWidth: cursorStrokeWidth,
          strokeLinecap: cursorStrokeLinecap,
          strokeDasharray: cursorStrokeDasharray
        }
      }
    );
  }
  renderTooltip() {
    return this.state.anchor !== null && /* @__PURE__ */ react_default.createElement(
      Popover_default,
      {
        "data-test": "tooltip",
        open: this.state.open,
        anchor: this.state.anchor,
        "data-test-value": this.state.tooltip,
        appearance: "inverted",
        defaultPlacement: "above",
        animation: false
      },
      /* @__PURE__ */ react_default.createElement(StyledTooltip, null, this.state.anchor !== null ? this.state.tooltip : void 0)
    );
  }
  /**
   * Renders one or more svg circles to highlight values on the sparkline
   * @method renderEndDots
   * @param {Array[Array[Number]]} points // x,y coordinates of values
   * @param {Number} dotsToShow           // number of end dots to display
   * @param {Number} xMargin              // used when calculating the dot radius
   * @returns {Object} React representation of SVG group
   * @private
   */
  renderEndDots(points, dotsToShow, xMargin) {
    const { endDotFillColor, endDotRadius, endDotStroke, endDotStrokeWidth } = this.props;
    return /* @__PURE__ */ react_default.createElement("g", null, points.slice(-dotsToShow).map((point) => /* @__PURE__ */ react_default.createElement(
      "circle",
      {
        key: `end-dot${point[0]}${point[1]}`,
        "data-test": "end-dot",
        cx: point[0],
        cy: point[1],
        r: endDotRadius === 0 ? xMargin : endDotRadius,
        style: {
          fill: endDotFillColor,
          stroke: endDotStroke,
          strokeWidth: endDotStrokeWidth
        }
      }
    )));
  }
  /**
   * Renders the line(s) above the area graph
   * @method renderPolyline
   * @param {Array} points
   * @returns {Object} SVG Group of polylines
   */
  renderPolyline(points) {
    const { data, lineColor, lineLength, lineStrokeWidth } = this.props;
    const linePoints = (0, lodash_exports.isFinite)(lineLength) && lineLength > 0 ? lineLength : points.length;
    const lines = this.getSegmentSets(data.slice(-linePoints), points.slice(-linePoints));
    return /* @__PURE__ */ react_default.createElement("g", { "data-test": "sparkline" }, lines.map((lineData) => /* @__PURE__ */ react_default.createElement(
      "polyline",
      {
        key: `line${lineData.join("")}`,
        "data-test": "polyline",
        style: {
          fill: "none",
          stroke: lineColor,
          strokeWidth: lineStrokeWidth,
          strokeLinejoin: "round",
          strokeLinecap: "round"
        },
        points: lineData.join(" ")
      }
    )));
  }
  render() {
    const {
      data,
      elementRef,
      showTooltip,
      showEndDot,
      endDotRadius,
      endDotStrokeWidth,
      endDotCount,
      height,
      isArea,
      lineStrokeWidth,
      width,
      title
    } = this.props;
    if (data.length === 0) {
      return null;
    }
    const xMargin = endDotRadius + endDotStrokeWidth / 2;
    const yMargin = Math.max(lineStrokeWidth / 2, endDotRadius + endDotStrokeWidth / 2);
    const points = this.dataToPoints(xMargin, yMargin);
    const dotsToShow = Math.max(showEndDot && 1, (0, lodash_exports.isFinite)(endDotCount) && endDotCount > 0 && endDotCount);
    return /* @__PURE__ */ react_default.createElement(
      "div",
      __spreadValues({
        "data-test": "line",
        "data-test-type": isArea ? "area" : "line",
        onMouseOut: () => {
          this.setState({
            open: false,
            anchor: null,
            rectArea: null,
            currentPointX: null
          });
        },
        ref: elementRef
      }, (0, lodash_exports.omit)(this.props, (0, lodash_exports.keys)(_SparkLine.propTypes))),
      /* @__PURE__ */ react_default.createElement(
        StyledSvg,
        {
          height,
          width,
          role: "img",
          "aria-labelledby": this.titleId,
          "data-test": "sparkline-svg"
        },
        /* @__PURE__ */ react_default.createElement("title", { id: this.titleId, "data-test": "sparkline-title" }, title || (0, i18n_exports._)("Source count over time sparkline trend")),
        /* @__PURE__ */ react_default.createElement("g", null, this.renderCursor(), this.renderPolyline(points), this.renderArea(points), dotsToShow ? this.renderEndDots(points, dotsToShow, xMargin) : null, showTooltip ? this.renderRect(points, xMargin) : null, showTooltip ? this.renderTooltip() : null)
      )
    );
  }
};
__publicField(_SparkLine, "propTypes", {
  /**
   * If true, data can contain `null` as a value and is treated as `0`. If false, this throws error when data contains `null`.
   */
  acceptNull: prop_types_default.bool,
  /** Array of numbers. These data numbers are converted to points and show on sparkline. */
  data: (props) => {
    if (!(0, lodash_exports.isArray)(props.data)) {
      return new Error("Data provided to Sparkline must be an array.");
    }
    if (props.acceptNull && !props.data.every((value) => (0, lodash_exports.isNull)(value) || (0, lodash_exports.isFinite)(value))) {
      return new Error("Data provided to Sparkline must be finite numbers or null.");
    }
    if (!props.acceptNull && !props.data.every((value) => (0, lodash_exports.isFinite)(value))) {
      return new Error("Data provided to Sparkline must be finite numbers.");
    }
    return null;
  },
  /** A React ref which is set to the DOM element when the component mounts and `null` when it unmounts. */
  elementRef: prop_types_default.oneOfType([prop_types_default.func, prop_types_default.object]),
  /** Sets the number of end dots to display. When showEndDot is set to `true`, endDotCount is at least 1. If set to a positive value, this overrides showEndDot. */
  endDotCount: prop_types_default.number,
  /** Fills color to the end dot. */
  endDotFillColor: prop_types_default.string,
  /**
   * Sets end dot radius. End dot radius must be less than or equal to the margin. By default, its value equals the margin.
   */
  endDotRadius: prop_types_default.number,
  /** Sets end dot circle stroke color. */
  endDotStroke: prop_types_default.string,
  /** Sets end dot circle stroke width in pixels. */
  endDotStrokeWidth: prop_types_default.number,
  /** Fills color to area. */
  fillColor: prop_types_default.string,
  /** Fills opacity to area. Value must be in 0 ~ 1. */
  fillOpacity: prop_types_default.string,
  /** Sets cursor stroke color. */
  cursorStroke: prop_types_default.string,
  /** Sets cursor stroke width in pixels. */
  cursorStrokeWidth: prop_types_default.number,
  /** Sets cursor line cap style. */
  cursorStrokeLinecap: prop_types_default.oneOf(["butt", "round", "square"]),
  /** Sets cursor dash array style. */
  cursorStrokeDasharray: prop_types_default.string,
  /**
   * Container height. If this value is specified, sparkline calculates the size using this height. If height isn't specified,
   * sparkline figures out the container height by itself.
   */
  height: prop_types_default.number.isRequired,
  /** When set to `true`, sparkline shows as area. */
  isArea: prop_types_default.bool,
  /** The sparkline line color. */
  lineColor: prop_types_default.string,
  /** Allows user to draw only the last data points for the line. */
  lineLength: prop_types_default.number,
  /** The sparkline line stroke width in pixels. */
  lineStrokeWidth: prop_types_default.number,
  /** Enable to show end dot. */
  showEndDot: prop_types_default.bool,
  /** Enable to show tooltip. */
  showTooltip: prop_types_default.bool,
  /** Sets the data value range and maximum value shown on sparkline. */
  yMax: prop_types_default.number,
  /** Sets the data value range and minimum value shown on sparkline. */
  yMin: prop_types_default.number,
  /**
   * The width of the container.
   */
  width: prop_types_default.number.isRequired,
  /** Sets the a11y title text on sparkline. */
  title: prop_types_default.string
});
__publicField(_SparkLine, "defaultProps", {
  acceptNull: false,
  data: [],
  showTooltip: true,
  endDotCount: 0,
  showEndDot: false,
  endDotRadius: 0,
  endDotFillColor: "white",
  endDotStroke: "black",
  endDotStrokeWidth: 0,
  fillColor: "#65a637",
  fillOpacity: ".1",
  cursorStroke: "#5184AF",
  cursorStrokeWidth: 3,
  cursorStrokeLinecap: "square",
  cursorStrokeDasharray: "1, 5",
  isArea: false,
  lineColor: "#65a637",
  lineStrokeWidth: 1
});
var SparkLine = _SparkLine;
var SparkLine_default = SparkLine;
//# sourceMappingURL=SparkLine.js.map
