/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/GaugeMajorTicks.jsx
var GaugeMajorTicks_exports = {};
__export(GaugeMajorTicks_exports, {
  MajorTick: () => MajorTick,
  default: () => GaugeMajorTicks_default,
  positionMajorTick: () => positionMajorTick
});
module.exports = __toCommonJS(GaugeMajorTicks_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport3 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport4 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// src/common/GaugeMajorTicks.jsx
var DEFAULT_NUM_OF_TICKS = 5;
var TICK_LENGTH_DELTA = 5;
var TICK_LABEL_PADDING_FACTOR = 3.2;
var MajorTickLine = styled_components_default.line`
    stroke: ${(props) => props.majorTickStrokeColor};
    stroke-width: 2px;
    stroke-dasharray: ${(props) => props.index === 0 ? 0 : 3};
`;
var MajorTickLabel = styled_components_default.text`
    font-size: 12px;
    font-family: Splunk Platform Sans, sans-serif;
    line-height: 19px;
    fill: ${(props) => props.majorTickFillColor};
    text-anchor: middle;
    text-align: center;
`;
var MajorTick = ({
  index,
  x1,
  y1,
  x2,
  y2,
  showLabels,
  label,
  labelX,
  labelY,
  majorTickStrokeColor,
  majorTickFillColor
}) => /* @__PURE__ */ react_default.createElement("g", null, /* @__PURE__ */ react_default.createElement(
  MajorTickLine,
  {
    "data-test": "major-tick-line",
    index,
    x1,
    y1,
    x2,
    y2,
    majorTickStrokeColor
  }
), showLabels && /* @__PURE__ */ react_default.createElement(
  MajorTickLabel,
  {
    x: labelX,
    y: labelY,
    majorTickFillColor,
    "data-test": "major-tick-label"
  },
  (0, numberUtils_exports.isNumerial)(label) ? (0, numberUtils_exports.formatNumber)(label, 0, {
    useThousandSeparators: true,
    useTrendUnits: true
  }) : label
));
MajorTick.propTypes = {
  index: prop_types_default.number,
  x1: prop_types_default.number,
  y1: prop_types_default.number,
  x2: prop_types_default.number,
  y2: prop_types_default.number,
  showLabels: prop_types_default.bool,
  label: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  labelX: prop_types_default.number,
  labelY: prop_types_default.number,
  majorTickStrokeColor: prop_types_default.string,
  majorTickFillColor: prop_types_default.string
};
var positionMajorTick = ({ width, height, startX, startY, orientation, numOfTicks, i }) => {
  let x1 = startX;
  let y1 = startY;
  let x2 = startX;
  let y2 = startY;
  let labelX = startX;
  let labelY;
  if (orientation === "vertical") {
    const y = height / numOfTicks * (numOfTicks - i) + startY;
    x1 -= TICK_LENGTH_DELTA;
    y1 = y;
    x2 += width + TICK_LENGTH_DELTA;
    y2 = y;
    labelX += width + TICK_LENGTH_DELTA * TICK_LABEL_PADDING_FACTOR;
    labelY = y;
  } else {
    const x = width / numOfTicks * i + startX;
    x1 = x;
    y1 -= TICK_LENGTH_DELTA;
    x2 = x;
    y2 += height + TICK_LENGTH_DELTA;
    labelX = x;
    labelY = y2 + 16;
  }
  return { x1, y1, x2, y2, labelX, labelY };
};
var MajorTicks = (_a) => {
  var props = __objRest(_a, []);
  const {
    width,
    height,
    startX,
    startY,
    min,
    max,
    majorUnit,
    orientation,
    showLabels,
    usePercentageRange,
    majorTickFillColor,
    majorTickStrokeColor
  } = props;
  const range = max - min;
  const numOfTicks = majorUnit === "auto" || Number.isNaN(Number(majorUnit)) || majorUnit <= 0 ? DEFAULT_NUM_OF_TICKS : range / majorUnit;
  const majorTicks = [];
  for (let i = 0; i <= numOfTicks; i += 1) {
    const { x1, y1, x2, y2, labelX, labelY } = positionMajorTick({
      width,
      height,
      startX,
      startY,
      orientation,
      numOfTicks,
      i
    });
    const label = usePercentageRange ? `${parseInt((i / numOfTicks - min / range) * 100, 10)}%` : parseInt(min + range / numOfTicks * i, 10);
    majorTicks.push(
      /* @__PURE__ */ react_default.createElement(
        MajorTick,
        {
          key: i,
          index: i,
          x1,
          y1,
          x2,
          y2,
          showLabels,
          label,
          labelX,
          labelY,
          majorTickFillColor,
          majorTickStrokeColor
        }
      )
    );
  }
  if (!Number.isInteger(numOfTicks)) {
    const extraNumOfTicks = Math.ceil(numOfTicks);
    const { x1, y1, x2, y2, labelX, labelY } = positionMajorTick({
      width,
      height,
      startX,
      startY,
      orientation,
      numOfTicks: extraNumOfTicks,
      i: extraNumOfTicks
    });
    majorTicks.push(
      /* @__PURE__ */ react_default.createElement(
        MajorTick,
        {
          key: extraNumOfTicks,
          id: extraNumOfTicks,
          x1,
          y1,
          x2,
          y2,
          showLabels,
          label: usePercentageRange ? "100%" : max,
          labelX,
          labelY,
          majorTickFillColor,
          majorTickStrokeColor
        }
      )
    );
  }
  return /* @__PURE__ */ react_default.createElement("g", null, majorTicks);
};
MajorTicks.propTypes = {
  width: prop_types_default.number,
  height: prop_types_default.number,
  startX: prop_types_default.number,
  startY: prop_types_default.number,
  min: prop_types_default.number,
  max: prop_types_default.number,
  majorUnit: prop_types_default.oneOfType([prop_types_default.string, prop_types_default.number]),
  orientation: prop_types_default.string,
  showLabels: prop_types_default.bool,
  usePercentageRange: prop_types_default.bool,
  majorTickFillColor: prop_types_default.string,
  majorTickStrokeColor: prop_types_default.string
};
MajorTicks.defaultProps = {
  min: 0,
  max: 100,
  majorUnit: "auto",
  orientation: "horizontal",
  showLabels: true,
  usePercentageRange: false
};
var GaugeMajorTicks_default = MajorTicks;
//# sourceMappingURL=GaugeMajorTicks.js.map
