/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/GaugeValueMarker.jsx
var GaugeValueMarker_exports = {};
__export(GaugeValueMarker_exports, {
  default: () => GaugeValueMarker_default,
  positionLabel: () => positionLabel,
  positionValueMarkerRect: () => positionValueMarkerRect
});
module.exports = __toCommonJS(GaugeValueMarker_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport3 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport4 = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// src/common/GaugeValueMarker.jsx
var MARKER_THICKNESS = 15;
var MARKER_INNER_LENGTH = 30;
var MARKER_LABEL_WIDTH = 60;
var MARKER_LABEL_HEIGHT = 25;
var RADIUS = 2;
var DELTA_LENGTH = 12;
var ValueMarkerRect = styled_components_default.path`
    stroke-width: 2px;
    fill: ${(props) => props.valueMarkerFillColor};
`;
var ValueMarkerLabelRect = styled_components_default.rect`
    fill: ${(props) => props.valueMarkerFillColor};
`;
var ValueMarkerLabel = styled_components_default.text`
    fill: ${(props) => props.valueMarkerLabelFillColor};
    font-size: 14px;
    font-family: Splunk Platform Sans, sans-serif;
    line-height: 16px;
    text-anchor: middle;
    text-align: center;
    dominant-baseline: middle;
`;
var positionValueMarkerRect = ({
  x,
  y,
  orientation,
  valueMarkerRectLength,
  alignCenter = false
}) => {
  let hLength = MARKER_THICKNESS;
  let vLength = valueMarkerRectLength;
  let markerStartX = alignCenter ? x - MARKER_THICKNESS / 2 : x - MARKER_THICKNESS;
  let markerStartY = y;
  let innerHLength = hLength / 3;
  let innerVLength = MARKER_INNER_LENGTH;
  let innerStartX = markerStartX + innerHLength;
  let innerStartY = markerStartY + 7;
  if (orientation === "vertical") {
    hLength = valueMarkerRectLength;
    vLength = MARKER_THICKNESS;
    markerStartX = x;
    markerStartY = alignCenter ? y - MARKER_THICKNESS / 2 : y;
    innerHLength = MARKER_INNER_LENGTH;
    innerVLength = vLength / 3;
    innerStartX = markerStartX + 7;
    innerStartY = markerStartY + innerVLength;
  }
  return `M${markerStartX},${markerStartY}h${hLength}a${RADIUS},${RADIUS} 0 0 1 ${RADIUS},${RADIUS}v${vLength - 2 * RADIUS}a${RADIUS},${RADIUS} 0 0 1 ${-RADIUS},${RADIUS}h${-hLength}a${RADIUS},${RADIUS} 0 0 1 ${-RADIUS},${-RADIUS}v${2 * RADIUS - vLength}a${RADIUS},${RADIUS} 0 0 1 ${RADIUS},${-RADIUS}zM${innerStartX},${innerStartY}v${innerVLength - RADIUS}a${RADIUS},${RADIUS} 0 0 0 ${RADIUS},${RADIUS}h${innerHLength - 2 * RADIUS}a${RADIUS},${RADIUS} 0 0 0 ${RADIUS},${-RADIUS}v${RADIUS - innerVLength}a${RADIUS},${RADIUS} 0 0 0 ${-RADIUS},${-RADIUS}h${2 * RADIUS - innerHLength}a${RADIUS},${RADIUS} 0 0 0 ${-RADIUS},${RADIUS}z`;
};
var positionLabel = ({ x, y, length, orientation, alignCenter = false }) => {
  let labelRectX = alignCenter ? x - MARKER_LABEL_WIDTH / 2 : x - MARKER_THICKNESS / 2 - MARKER_LABEL_WIDTH / 2;
  let labelRectY = y + length;
  if (orientation === "vertical") {
    labelRectX = x + length;
    labelRectY = alignCenter ? y - MARKER_LABEL_HEIGHT / 2 : y - (MARKER_LABEL_HEIGHT - MARKER_THICKNESS) / 2;
  }
  const labelX = labelRectX + MARKER_LABEL_WIDTH / 2;
  const labelY = labelRectY + MARKER_LABEL_HEIGHT / 2;
  return { labelRectX, labelRectY, labelX, labelY };
};
var ValueMarker = (_a) => {
  var props = __objRest(_a, []);
  const {
    x,
    y,
    length,
    min,
    max,
    value,
    orientation,
    showValue,
    usePercentageValue,
    valueMarkerFillColor,
    valueMarkerLabelFillColor,
    alignCenter
  } = props;
  const valueMarkerRectLength = length + DELTA_LENGTH;
  const { labelRectX, labelRectY, labelX, labelY } = positionLabel({
    x,
    y,
    length,
    orientation,
    alignCenter
  });
  return /* @__PURE__ */ react_default.createElement("g", null, /* @__PURE__ */ react_default.createElement(
    ValueMarkerRect,
    {
      "data-test": "value-marker-rect",
      d: positionValueMarkerRect({ x, y, orientation, valueMarkerRectLength, alignCenter }),
      valueMarkerFillColor
    }
  ), showValue && /* @__PURE__ */ react_default.createElement("g", null, /* @__PURE__ */ react_default.createElement(
    ValueMarkerLabelRect,
    {
      "data-test": "value-marker-label-rect",
      x: labelRectX,
      y: labelRectY,
      width: MARKER_LABEL_WIDTH,
      height: MARKER_LABEL_HEIGHT,
      rx: RADIUS,
      ry: RADIUS,
      valueMarkerFillColor
    }
  ), /* @__PURE__ */ react_default.createElement(
    ValueMarkerLabel,
    {
      "data-test": "value-marker-label",
      x: labelX,
      y: labelY,
      valueMarkerLabelFillColor
    },
    usePercentageValue ? `${(value / (max - min) * 100).toFixed(2)}%` : (0, numberUtils_exports.formatNumber)(value, 0, {
      useThousandSeparators: true,
      useTrendUnits: true
    })
  )));
};
ValueMarker.propTypes = {
  x: prop_types_default.number,
  y: prop_types_default.number,
  length: prop_types_default.number,
  min: prop_types_default.number,
  max: prop_types_default.number,
  value: prop_types_default.number,
  orientation: prop_types_default.string,
  showValue: prop_types_default.bool,
  usePercentageValue: prop_types_default.bool,
  valueMarkerFillColor: prop_types_default.string,
  valueMarkerLabelFillColor: prop_types_default.string,
  alignCenter: prop_types_default.bool
};
ValueMarker.defaultProps = {
  min: 0,
  max: 100,
  orientation: "horizontal",
  showValue: true,
  usePercentageValue: false,
  alignCenter: false
};
var GaugeValueMarker_default = ValueMarker;
//# sourceMappingURL=GaugeValueMarker.js.map
