/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/chartingUtils.ts
var chartingUtils_exports = {};
__export(chartingUtils_exports, {
  constructAdditionalTooltipFieldsMap: () => constructAdditionalTooltipFieldsMap,
  constructFieldsAndColumns: () => constructFieldsAndColumns,
  convertOverlayFields: () => convertOverlayFields,
  convertY2AxisOptions: () => convertY2AxisOptions,
  getAnnotations: () => getAnnotations,
  isMultiSeriesData: () => isMultiSeriesData,
  mapToValues: () => mapToValues,
  shouldEnableSearchZoom: () => shouldEnableSearchZoom,
  toArrayForSeries: () => toArrayForSeries,
  truncateData: () => truncateData
});
module.exports = __toCommonJS(chartingUtils_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// src/common/chartingUtils.ts
var getAnnotations = ({ annotationX, annotationColor, annotationLabel }) => annotationX && annotationX.length ? annotationX.map((timestamp, i) => ({
  color: annotationColor && annotationColor[i],
  label: annotationLabel && annotationLabel[i],
  time: timestamp
})) : [];
var truncateData = (dataSet, truncationLimit) => {
  if (!dataSet) {
    return null;
  }
  const limit = parseInt(truncationLimit, 10);
  if (!limit || limit <= 0) {
    return dataSet;
  }
  const truncatedData = __spreadValues({}, dataSet);
  truncatedData.columns = truncatedData.columns.map(
    (columnData) => columnData && Array.isArray(columnData) ? columnData.slice(0, limit) : columnData
  );
  return truncatedData;
};
var mapToValues = (optionValuesSCMapping) => (options) => {
  const convertedOptions = __spreadValues({}, options);
  Object.keys(optionValuesSCMapping).forEach((key) => {
    if ((0, lodash_exports.has)(options, key)) {
      const updatedValue = optionValuesSCMapping[key][options[key]];
      if (!(0, lodash_exports.isUndefined)(updatedValue)) {
        convertedOptions[key] = updatedValue;
      }
    }
  });
  return convertedOptions;
};
var convertY2AxisOptions = (_a) => {
  var _b = _a, {
    y2Fields
  } = _b, originalOptions = __objRest(_b, [
    "y2Fields"
  ]);
  const convertedOptions = __spreadValues({}, originalOptions);
  if (y2Fields) {
    convertedOptions["axisY2.enabled"] = true;
    convertedOptions["axisY2.fields"] = (0, lodash_exports.isArray)(y2Fields) ? y2Fields.filter((name) => name).join(",") : y2Fields;
  }
  return convertedOptions;
};
var convertOverlayFields = (originalOptions) => {
  const convertedOptions = __spreadValues({}, originalOptions);
  const { overlayFields } = originalOptions;
  if (overlayFields) {
    convertedOptions.overlayFields = Array.isArray(overlayFields) ? overlayFields.filter((field) => field).map((field) => field.trim()).join(",") : overlayFields;
  }
  return convertedOptions;
};
var isMultiSeriesData = (data) => Array.isArray(data) && Array.isArray(data[0]);
var toArrayForSeries = (data, value) => isMultiSeriesData(data) ? value : [value];
var constructFieldsAndColumns = ({
  x = [],
  y = [],
  xField,
  yFields,
  y2,
  y2Fields
}) => {
  const columns = [x.map(String), ...toArrayForSeries(y, y).map((series) => series.map(String))];
  const yFieldsArray = toArrayForSeries(y, yFields);
  const fields = [{ name: xField }, ...yFieldsArray.map((field) => ({ name: field }))];
  if (y2Fields) {
    const y2FieldsArray = toArrayForSeries(y2, y2Fields);
    const y2AsArray = toArrayForSeries(y2, y2).map((series) => series == null ? void 0 : series.map(String));
    y2FieldsArray.forEach((y2Field, index) => {
      if (yFieldsArray.indexOf(y2Field) === -1 && y2AsArray[index]) {
        fields.push({
          name: y2Field
        });
        columns.push(y2AsArray[index]);
      }
    });
  }
  return {
    columns,
    fields
  };
};
function constructAdditionalTooltipFieldsMap({ fields, columns, additionalTooltipFields }) {
  const map = {};
  additionalTooltipFields == null ? void 0 : additionalTooltipFields.forEach((fieldName) => {
    const index = fields.findIndex((f) => f.name === fieldName);
    if (index !== -1) {
      map[fieldName] = columns[index];
    }
  });
  return map;
}
var shouldEnableSearchZoom = (eventHandlers = [], xField = "") => {
  const rangeSelectEventHandler = eventHandlers.find(
    (eventHandler) => {
      var _a;
      return (_a = eventHandler.options.events) == null ? void 0 : _a.includes("range.select");
    }
  );
  const xAxisIsTime = xField === "_time";
  return !!rangeSelectEventHandler && xAxisIsTime;
};
//# sourceMappingURL=chartingUtils.js.map
