/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/docUtils.tsx
var docUtils_exports = {};
__export(docUtils_exports, {
  convertToDashboardJSON: () => convertToDashboardJSON,
  extractDataFromReactCode: () => extractDataFromReactCode,
  extractDocItems: () => extractDocItems,
  formatCodeStringToObject: () => formatCodeStringToObject,
  getFormatterClassdesc: () => getFormatterClassdesc
});
module.exports = __toCommonJS(docUtils_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/react-docs/UtilPage
var UtilPage_exports = {};
__export(UtilPage_exports, {
  default: () => UtilPage_default
});
var defaultImport2 = __toESM(require("@splunk/react-docs/UtilPage"));
__reExport(UtilPage_exports, require("@splunk/react-docs/UtilPage"));
var UtilPage_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// src/common/docUtils.tsx
var sharedSelectors = ["getField", "getType", "min", "max"];
var formatSidebarItemName = (name, className) => {
  return sharedSelectors.find((sharedSelector) => name === sharedSelector) ? `${className}#${name}` : name;
};
var removePrependedClassName = (longname = "") => longname.slice(longname.indexOf("#") + 1);
var formatDSLSelectorDocs = (docs) => docs.map((doc) => __spreadProps(__spreadValues({}, doc), {
  longname: removePrependedClassName(doc.longname)
}));
var getFormatterClassdesc = (formatterDocs, name) => ({
  name,
  markdown: `# ${name}
 ${formatterDocs.find((doc) => doc.name === name && doc.kind === "class").classdesc}`
});
var extractDocItems = (docs, className) => {
  const classHeaderDoc = docs[0];
  const fileDoc = docs[docs.length - 1];
  const filteredDocs = formatDSLSelectorDocs(docs).filter(
    ({ access, comment }) => access === "public" && comment
  );
  return filteredDocs.map((doc) => ({
    name: formatSidebarItemName(doc.name, className),
    component: function UtilDoc() {
      return /* @__PURE__ */ react_exports.createElement(
        UtilPage_default,
        {
          title: `${className}#${doc.name}`,
          status: 1,
          docs: [classHeaderDoc, doc, fileDoc]
        }
      );
    }
  })).sort((a, b) => a.name.localeCompare(b.name));
};
var formatCodeStringToObject = (codeString, regexMatch) => {
  const match = regexMatch.exec(codeString);
  if (!match) return null;
  const stringToParse = `{${match[1]}}`;
  const removedCommas = stringToParse.replace(/,(?!\s*?[-{["'\w])/g, "");
  const backQuotes = removedCommas.replace(/"/g, "`");
  const doubleQuotes = backQuotes.replace(/'/g, '"');
  const singleQuotes = doubleQuotes.replace(/`/g, "'");
  const quotesAroundKeys = singleQuotes.replace(/\b(\w+)\s*:(?=\s)/g, '"$1":');
  let retval = null;
  try {
    retval = JSON.parse(quotesAroundKeys);
  } catch (e) {
    console.error(e);
  }
  return retval;
};
var extractDataFromReactCode = (codeString) => {
  var _a;
  const primaryRegex = /dataSources={{([\s\S]*?primary:[\s\S]*?)}}/;
  const { primary } = (_a = formatCodeStringToObject(codeString, primaryRegex)) != null ? _a : {};
  const optionsRegex = /options={{([\s\S]*?)}}/;
  const options = formatCodeStringToObject(codeString, optionsRegex);
  const contextRegex = /context={{([\s\S]*?)}}/;
  const context = formatCodeStringToObject(codeString, contextRegex);
  return { primary, options, context };
};
var convertToDashboardJSON = (codeString, type) => {
  const { options, primary, context } = extractDataFromReactCode(codeString);
  return __spreadProps(__spreadValues({
    visualizations: {
      test_viz: __spreadValues(__spreadValues(__spreadValues({
        type
      }, options ? { options } : {}), primary ? { dataSources: { primary: "primary" } } : {}), context ? { context } : {})
    }
  }, primary ? { dataSources: { primary: { type: "ds.test", options: primary } } } : {}), {
    defaults: {
      dataSources: {
        global: {
          options: {
            queryParameters: {
              latest: "$global_time.latest$",
              earliest: "$global_time.earliest$"
            }
          }
        }
      }
    },
    inputs: {
      input_global_trp: {
        type: "input.timerange",
        options: {
          token: "global_time",
          defaultValue: "-24h@h,now"
        },
        title: "Global Time Range"
      }
    },
    layout: {
      type: "absolute",
      options: {},
      structure: [
        {
          item: "test_viz",
          type: "block",
          position: {
            x: 0,
            y: 0,
            w: 800,
            h: 500
          }
        }
      ],
      globalInputs: ["input_global_trp"]
    }
  });
};
//# sourceMappingURL=docUtils.js.map
