/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/gaugeUtils.ts
var gaugeUtils_exports = {};
__export(gaugeUtils_exports, {
  FILL_THICKNESS: () => FILL_THICKNESS,
  GAUGE_THICKNESS: () => GAUGE_THICKNESS,
  assignGaugeColor: () => assignGaugeColor,
  convertToGaugeProperties: () => convertToGaugeProperties,
  getFillBarDimensions: () => getFillBarDimensions,
  getFillerGaugeValueMarkerPositions: () => getFillerGaugeValueMarkerPositions,
  getGaugeBarHeight: () => getGaugeBarHeight,
  getGaugeBarLength: () => getGaugeBarLength,
  getGaugeBarStartPositions: () => getGaugeBarStartPositions,
  getGaugeBarWidth: () => getGaugeBarWidth,
  getGaugeDimensions: () => getGaugeDimensions,
  getGaugeHeight: () => getGaugeHeight,
  getGaugeLength: () => getGaugeLength,
  getGaugeRange: () => getGaugeRange,
  getGaugeStartPosition: () => getGaugeStartPosition,
  getGaugeWidth: () => getGaugeWidth,
  getGradientDimensions: () => getGradientDimensions,
  getGradientStopColors: () => getGradientStopColors,
  getGradientStopOffsets: () => getGradientStopOffsets,
  getGradientStops: () => getGradientStops,
  getMarkerBarDimensions: () => getMarkerBarDimensions,
  getMarkerGaugeValueMarkerPositions: () => getMarkerGaugeValueMarkerPositions,
  getSortedRanges: () => getSortedRanges,
  mapToOldKey: () => mapToOldKey,
  mapValueLabelDisplay: () => mapValueLabelDisplay,
  validateRanges: () => validateRanges
});
module.exports = __toCommonJS(gaugeUtils_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualizations-shared/colorConstants
var colorConstants_exports = {};
__export(colorConstants_exports, {
  default: () => colorConstants_default
});
var defaultImport2 = __toESM(require("@splunk/visualizations-shared/colorConstants"));
__reExport(colorConstants_exports, require("@splunk/visualizations-shared/colorConstants"));
var colorConstants_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport3 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/common/gaugeUtils.ts
var GAUGE_THICKNESS = 50;
var FILL_THICKNESS = 38;
var GRADIENT_STOP_OFFSET_MIN = 0;
var GRADIENT_STOP_OFFSET_MAX = 100;
var getGaugeWidth = ({ containerWidth, orientation }) => orientation === "vertical" ? GAUGE_THICKNESS : containerWidth * 0.8;
var getGaugeHeight = ({ containerHeight, orientation }) => orientation === "vertical" ? containerHeight * 0.8 : GAUGE_THICKNESS;
var getGaugeLength = ({ containerWidth, containerHeight, orientation }) => orientation === "vertical" ? getGaugeHeight({ containerHeight, orientation }) : getGaugeWidth({ containerWidth, orientation });
var getGaugeStartPosition = ({ containerWidth, containerHeight, gaugeLength, orientation }) => {
  let gaugeStartX = (containerWidth - gaugeLength) / 2;
  let gaugeStartY = (containerHeight - GAUGE_THICKNESS) / 2;
  if (orientation === "vertical") {
    gaugeStartX = (containerWidth - GAUGE_THICKNESS) / 2;
    gaugeStartY = (containerHeight - gaugeLength) / 2;
  }
  return { gaugeStartX, gaugeStartY };
};
var getGaugeDimensions = ({ containerWidth, containerHeight, orientation }) => {
  const gaugeLength = getGaugeLength({ containerWidth, containerHeight, orientation });
  const { gaugeStartX, gaugeStartY } = getGaugeStartPosition({
    containerWidth,
    containerHeight,
    gaugeLength,
    orientation
  });
  const gaugeWidth = getGaugeWidth({ containerWidth, orientation });
  const gaugeHeight = getGaugeHeight({ containerHeight, orientation });
  return {
    gaugeLength,
    gaugeStartX,
    gaugeStartY,
    gaugeWidth,
    gaugeHeight
  };
};
var assignGaugeColor = ({ value, min, max }) => {
  const rate = (value - min) / (max - min);
  if (rate <= 0.3) {
    return colorConstants_exports.SEMANTIC_SUCCESS;
  }
  if (rate > 0.3 && rate <= 0.6) {
    return colorConstants_exports.SEMANTIC_WARNING;
  }
  return colorConstants_exports.SEMANTIC_ERROR;
};
var getGaugeBarLength = ({ gaugeLength, value, min, max }) => {
  if (max < min) {
    return null;
  }
  if (value >= max) {
    return gaugeLength;
  }
  if (value < min) {
    return 0;
  }
  return gaugeLength * (value - min) / (max - min);
};
var getGaugeBarStartPositions = ({
  gaugeStartX,
  gaugeStartY,
  gaugeWidth,
  gaugeHeight,
  gaugeBarLength,
  orientation
}) => {
  let gaugeBarX = gaugeStartX;
  let gaugeBarY = gaugeStartY;
  if (orientation === "vertical") {
    gaugeBarX += (gaugeWidth - FILL_THICKNESS) / 2;
    gaugeBarY += gaugeHeight - gaugeBarLength;
  } else {
    gaugeBarY += (gaugeHeight - FILL_THICKNESS) / 2;
  }
  return {
    gaugeBarX,
    gaugeBarY
  };
};
var getGaugeBarWidth = ({ gaugeBarLength, orientation }) => orientation === "vertical" ? FILL_THICKNESS : gaugeBarLength;
var getGaugeBarHeight = ({ gaugeBarLength, orientation }) => orientation === "vertical" ? gaugeBarLength : FILL_THICKNESS;
var getFillBarDimensions = ({
  gaugeLength,
  gaugeStartX,
  gaugeStartY,
  gaugeWidth,
  gaugeHeight,
  value,
  min,
  max,
  orientation
}) => {
  const gaugeBarLength = getGaugeBarLength({ gaugeLength, value, max, min });
  const { gaugeBarX: fillBarX, gaugeBarY: fillBarY } = getGaugeBarStartPositions({
    gaugeStartX,
    gaugeStartY,
    gaugeWidth,
    gaugeHeight,
    gaugeBarLength,
    orientation
  });
  const fillBarWidth = getGaugeBarWidth({ gaugeBarLength, orientation });
  const fillBarHeight = getGaugeBarHeight({ gaugeBarLength, orientation });
  return {
    fillBarLength: gaugeBarLength,
    fillBarX,
    fillBarY,
    fillBarWidth,
    fillBarHeight
  };
};
var getFillerGaugeValueMarkerPositions = ({ fillBarX, fillBarY, fillBarLength, orientation }) => {
  let valueMarkerX = fillBarX;
  let valueMarkerY = fillBarY;
  if (orientation === "vertical") {
    valueMarkerX -= (GAUGE_THICKNESS - FILL_THICKNESS) / 4;
  } else {
    valueMarkerX += fillBarLength;
    valueMarkerY -= (GAUGE_THICKNESS - FILL_THICKNESS) / 4;
  }
  return {
    valueMarkerX,
    valueMarkerY
  };
};
var getMarkerBarDimensions = ({
  gaugeLength,
  gaugeStartX,
  gaugeStartY,
  gaugeWidth,
  gaugeHeight,
  orientation
}) => {
  const gaugeBarLength = gaugeLength;
  const { gaugeBarX: markerBarX, gaugeBarY: markerBarY } = getGaugeBarStartPositions({
    gaugeStartX,
    gaugeStartY,
    gaugeWidth,
    gaugeHeight,
    gaugeBarLength,
    orientation
  });
  const markerBarWidth = getGaugeBarWidth({ gaugeBarLength, orientation });
  const markerBarHeight = getGaugeBarHeight({ gaugeBarLength, orientation });
  return {
    markerBarLength: gaugeBarLength,
    markerBarX,
    markerBarY,
    markerBarWidth,
    markerBarHeight
  };
};
var getMarkerGaugeValueMarkerPositions = ({
  markerBarX,
  markerBarY,
  markerBarHeight,
  markerBarLength: gaugeLength,
  orientation,
  value,
  min,
  max
}) => {
  let valueMarkerX = markerBarX;
  let valueMarkerY = markerBarY;
  if (orientation === "vertical") {
    valueMarkerY += markerBarHeight - getGaugeBarLength({ gaugeLength, value, max, min });
    valueMarkerX -= (GAUGE_THICKNESS - FILL_THICKNESS) / 4;
  } else {
    valueMarkerX += getGaugeBarLength({ gaugeLength, value, max, min });
    valueMarkerY -= (GAUGE_THICKNESS - FILL_THICKNESS) / 4;
  }
  return {
    valueMarkerX,
    valueMarkerY
  };
};
var getSortedRanges = (ranges) => ranges.sort((a, b) => a.from - b.from);
var validateRanges = (ranges) => {
  if (!ranges.length) {
    return (0, i18n_exports._)('Prop "ranges" is missing entries');
  }
  if (ranges.some((range) => range.from >= range.to)) {
    return (0, i18n_exports._)('Prop "ranges" has invalid entries: invalid range');
  }
  if (ranges.length !== (0, lodash_exports.uniqBy)(ranges, "to").length || ranges.length !== (0, lodash_exports.uniqBy)(ranges, "from").length) {
    return (0, i18n_exports._)('Prop "ranges" has invalid entries: duplicate values');
  }
  const sortedRanges = getSortedRanges(ranges);
  for (let i = 1; i < sortedRanges.length; i += 1) {
    if (sortedRanges[i].from !== sortedRanges[i - 1].to) {
      return (0, i18n_exports._)('Prop "ranges" has invalid entries: discontinuous ranges');
    }
  }
  return null;
};
var getGaugeRange = (ranges) => {
  const min = Math.min(...ranges.map((range) => range.from));
  const max = Math.max(...ranges.map((range) => range.to));
  return { min, max };
};
var getGradientStopOffsets = ({ ranges, orientation }) => {
  const { min, max } = getGaugeRange(ranges);
  const offsetScale = (GRADIENT_STOP_OFFSET_MAX - GRADIENT_STOP_OFFSET_MIN) / (max - min);
  let offsets = ranges.map((range) => Math.abs(range.from - range.to) * offsetScale);
  offsets = orientation === "vertical" ? offsets.reverse() : offsets;
  const cumulativeOffsets = [];
  offsets.reduce((accumulator, currentValue, idx) => {
    cumulativeOffsets[idx] = accumulator + currentValue;
    return cumulativeOffsets[idx];
  }, 0);
  return cumulativeOffsets;
};
var getGradientStopColors = ({ ranges, orientation }) => {
  const stopColors = ranges.map((range) => range.value);
  return orientation === "vertical" ? stopColors.reverse() : stopColors;
};
var getGradientStops = ({ ranges, orientation }) => {
  const stops = [];
  const offsets = getGradientStopOffsets({ ranges, orientation });
  const stopColors = getGradientStopColors({ ranges, orientation });
  stops.push({ offset: `${offsets[0]}%`, stopColor: stopColors[0] });
  for (let i = 1; i < ranges.length; i += 1) {
    stops.push({ offset: `${offsets[i - 1]}%`, stopColor: stopColors[i] });
    stops.push({ offset: `${offsets[i]}%`, stopColor: stopColors[i] });
  }
  return stops;
};
var getGradientDimensions = (orientation) => {
  const x1 = "0%";
  const y1 = "0%";
  const x2 = orientation === "horizontal" ? "100%" : "0%";
  const y2 = orientation === "horizontal" ? "0%" : "100%";
  return { x1, y1, x2, y2 };
};
var gaugeOptionsMapping = {
  majorTickInterval: "majorUnit",
  gaugeRanges: "ranges"
};
var mapToOldKey = (options) => (0, lodash_exports.mapKeys)(options, (val, key) => gaugeOptionsMapping[key] ? gaugeOptionsMapping[key] : key);
var mapValueLabelDisplay = (labelOrValue, options) => {
  const rangeOrValue = labelOrValue === "value" ? "Value" : "Range";
  const showKey = labelOrValue === "value" ? "showValue" : "showLabels";
  const percentKey = `usePercentage${rangeOrValue}`;
  const optionString = `${labelOrValue}Display`;
  const newOptions = __spreadValues({}, options);
  if (newOptions[optionString]) {
    if (newOptions[optionString] === "number") {
      newOptions[showKey] = true;
      newOptions[percentKey] = false;
    } else if (newOptions[optionString] === "percentage") {
      newOptions[showKey] = true;
      newOptions[percentKey] = true;
    } else {
      newOptions[showKey] = false;
      newOptions[percentKey] = false;
    }
  }
  return (0, lodash_exports.omit)(newOptions, [optionString]);
};
var convertToGaugeProperties = (originalOptions) => (0, lodash_exports.chain)(mapToOldKey(originalOptions)).thru((options) => mapValueLabelDisplay("label", options)).thru((options) => mapValueLabelDisplay("value", options)).value();
//# sourceMappingURL=gaugeUtils.js.map
