/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/shapeUtils.tsx
var shapeUtils_exports = {};
__export(shapeUtils_exports, {
  ClickableShape: () => ClickableShape,
  getStyledShape: () => getStyledShape,
  mapToOldKey: () => mapToOldKey
});
module.exports = __toCommonJS(shapeUtils_exports);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport2 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/themes/pick
var pick_exports = {};
__export(pick_exports, {
  default: () => pick_default
});
var defaultImport3 = __toESM(require("@splunk/themes/pick"));
__reExport(pick_exports, require("@splunk/themes/pick"));
var pick_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/themes/variables
var variables_exports = {};
__export(variables_exports, {
  default: () => variables_default
});
var defaultImport4 = __toESM(require("@splunk/themes/variables"));
__reExport(variables_exports, require("@splunk/themes/variables"));
var variables_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/visualizations-shared/propUtils
var propUtils_exports = {};
__export(propUtils_exports, {
  default: () => propUtils_default
});
var defaultImport5 = __toESM(require("@splunk/visualizations-shared/propUtils"));
__reExport(propUtils_exports, require("@splunk/visualizations-shared/propUtils"));
var propUtils_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport6 = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/react-ui/ScreenReaderContent
var ScreenReaderContent_exports = {};
__export(ScreenReaderContent_exports, {
  default: () => ScreenReaderContent_default
});
var defaultImport7 = __toESM(require("@splunk/react-ui/ScreenReaderContent"));
__reExport(ScreenReaderContent_exports, require("@splunk/react-ui/ScreenReaderContent"));
var ScreenReaderContent_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/ui-utils/id
var id_exports = {};
__export(id_exports, {
  default: () => id_default
});
var defaultImport8 = __toESM(require("@splunk/ui-utils/id"));
__reExport(id_exports, require("@splunk/ui-utils/id"));
var id_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport9 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// src/common/shapeUtils.tsx
var shapeOptionsMapping = {
  fillColor: "fill",
  strokeColor: "stroke",
  strokeDashStyle: "strokeDasharray",
  strokeJoinStyle: "strokeLinejoin"
};
var mapToOldKey = (options) => (0, lodash_exports.mapKeys)(options, (val, key) => shapeOptionsMapping[key] ? shapeOptionsMapping[key] : key);
var getStyledShape = (shape) => styled_components_default(shape)`
    fill: ${(props) => props.fill && (0, propUtils_exports.formatColor)(props.fill) || pick_default({
  enterprise: {
    light: variables_default.gray80,
    dark: variables_default.gray25
  },
  prisma: variables_default.backgroundColorSidebar
})(props)};
    stroke: ${(props) => props.stroke && (0, propUtils_exports.formatColor)(props.stroke) || pick_default({
  enterprise: {
    dark: variables_default.gray80,
    light: variables_default.textColor
  },
  prisma: variables_default.neutral500
})(props)};
`;
function ClickableShape({ children, onClick, shape }) {
  const descriptionId = (0, react_exports.useMemo)(() => (0, id_exports.createDOMID)("clickable-svg-description"), []);
  return /* @__PURE__ */ react_default.createElement(StyledDiv, null, /* @__PURE__ */ react_default.createElement(ScreenReaderContent_default, { id: descriptionId }, (0, i18n_exports._)("Click to trigger interaction")), children, /* @__PURE__ */ react_default.createElement(
    StyledButton,
    {
      onClick,
      "aria-label": shape === "rect" ? (0, i18n_exports._)("Rectangle visualization") : (0, i18n_exports._)("Ellipse visualization"),
      "aria-describedby": descriptionId,
      shape
    }
  ));
}
var StyledDiv = styled_components_default.div`
    display: inline-grid;
    grid-template: 1fr / 1fr;

    & > * {
        grid-row-start: 1;
        grid-column-start: 1;
    }
`;
var StyledButton = styled_components_default.button`
    padding: 0;
    border: none;
    background: none;
    cursor: pointer;
    &:focus {
        outline: none;
        ${(props) => props.shape === "rect" ? styled_components_exports.css`
                      box-shadow: ${variables_default.focusShadow};
                  ` : (
  // clip-path would clip the shadow for ellipse, so we use drop-shadow filters to simulate it
  styled_components_exports.css`
                      svg:has(+ &) > ellipse {
                          filter: drop-shadow(2px 0px 1px ${variables_default.focusColor})
                              drop-shadow(-2px 0px 1px ${variables_default.focusColor})
                              drop-shadow(0px 2px 1px ${variables_default.focusColor})
                              drop-shadow(0px -2px 1px ${variables_default.focusColor});
                      }
                  `
)}
    }
    ${(props) => props.shape === "ellipse" && `
        clip-path: ellipse(50% 50% at 50% 50%);
    `}
`;
//# sourceMappingURL=shapeUtils.js.map
