/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/utils/configUtils.ts
var configUtils_exports2 = {};
__export(configUtils_exports2, {
  enhanceConfig: () => enhanceConfig,
  enhanceOptionsSchemaWithDynamicOptions: () => visualization_schemas_exports.enhanceOptionsSchemaWithDynamicOptions,
  generatePrecisionValues: () => generatePrecisionValues,
  getInitialPreset: () => getInitialPreset,
  insertLayout: () => insertLayout,
  isDynamicOption: () => configUtils_exports.isDynamicOption,
  uncollapseEditorConfig: () => uncollapseEditorConfig
});
module.exports = __toCommonJS(configUtils_exports2);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualizations-shared/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport2 = __toESM(require("@splunk/visualizations-shared/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations-shared/configUtils"));
var configUtils_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualization-schemas
var visualization_schemas_exports = {};
__export(visualization_schemas_exports, {
  default: () => visualization_schemas_default
});
var defaultImport3 = __toESM(require("@splunk/visualization-schemas"));
__reExport(visualization_schemas_exports, require("@splunk/visualization-schemas"));
var visualization_schemas_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/common/utils/configUtils.ts
function enhanceConfig(vizConfig) {
  const enhancedConfig = __spreadValues({}, vizConfig);
  enhancedConfig.editorConfig = vizConfig.editorConfig.map(
    (config) => {
      return __spreadProps(__spreadValues({}, config), { open: config.open || false });
    }
  );
  return enhancedConfig;
}
function uncollapseEditorConfig(vizConfig) {
  const editorPanelUncollapsedConfig = __spreadValues({}, vizConfig);
  editorPanelUncollapsedConfig.editorConfig = vizConfig.editorConfig.map(
    (config) => {
      return __spreadProps(__spreadValues({}, config), { open: true });
    }
  );
  return editorPanelUncollapsedConfig;
}
function hasCompatibleContexts(vizContext, presetContext) {
  const presetContextKeys = Object.keys(presetContext);
  return presetContextKeys.every(
    (contextKey) => presetContext[contextKey] === void 0 && vizContext[contextKey] === void 0 || presetContext[contextKey] !== void 0 && vizContext[contextKey] !== void 0
  );
}
function hasCompatibleOptions(vizOptions, presetOptions) {
  const presetOptionKeys = Object.keys(presetOptions);
  return presetOptionKeys.every(
    (optionKey) => (0, configUtils_exports.isDynamicOption)(presetOptions[optionKey]) === (0, configUtils_exports.isDynamicOption)(vizOptions[optionKey])
  );
}
function getInitialPreset(vizContext, vizOptions, presets) {
  return presets.find((preset) => {
    const presetContext = (0, lodash_exports.get)(preset, ["value", "context"], {});
    const presetOptions = (0, lodash_exports.get)(preset, ["value", "options"], {});
    const presetContextKeys = Object.keys(presetContext);
    const presetOptionKeys = Object.keys(presetOptions);
    if (presetContextKeys.length === 0 || presetOptionKeys.length === 0) return false;
    return hasCompatibleContexts(vizContext, presetContext) && hasCompatibleOptions(vizOptions, presetOptions);
  });
}
function generatePrecisionValues(numPrecisionValues) {
  return (0, lodash_exports.range)(0, numPrecisionValues + 1).map(
    (i) => ({
      label: `${i} (0${i > 0 ? "." : ""}${"0".repeat(i)})`,
      // e.g. 0.000 for numPrecisionValues = 3
      value: i
    })
  );
}
var insertLayout = (layout, index, ...layoutItems) => [
  // copy part of the array before the specified index
  ...layout.slice(0, index),
  // inserted layout item
  ...layoutItems,
  // copy part of the array after the specified index
  ...layout.slice(index)
];
//# sourceMappingURL=configUtils.js.map
