/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/utils/dataUtils.ts
var dataUtils_exports = {};
__export(dataUtils_exports, {
  calculateDownsamplingThreshold: () => calculateDownsamplingThreshold,
  calculateThresholdOnRangeSelect: () => calculateThresholdOnRangeSelect,
  convertToArrOfObjects: () => convertToArrOfObjects,
  downsampleDataSources: () => downsampleDataSources,
  isDownsamplingEnabledForViz: () => isDownsamplingEnabledForViz
});
module.exports = __toCommonJS(dataUtils_exports);

// esm-externals:@splunk/visualizations-shared/numberUtils
var numberUtils_exports = {};
__export(numberUtils_exports, {
  default: () => numberUtils_default
});
var defaultImport = __toESM(require("@splunk/visualizations-shared/numberUtils"));
__reExport(numberUtils_exports, require("@splunk/visualizations-shared/numberUtils"));
var numberUtils_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// src/common/utils/dataUtils.ts
var convertToArrOfObjects = (columns, fields) => {
  if (!columns || !columns[0] || !columns[0].length) return [];
  const data = [];
  for (let i = 0; i < columns[0].length; i += 1) {
    const newObj = {};
    fields.forEach((field, index) => {
      const fieldName = typeof field === "string" ? field : field.name;
      if (columns[index][i] === "") {
        newObj[fieldName] = null;
      } else {
        newObj[fieldName] = columns[index][i];
      }
    });
    data.push(newObj);
  }
  return data;
};
var largestTriangleThreeBuckets = (data, threshold, preferredDownsampleIndices) => {
  const dataLength = data.length;
  const downsampledIndices = [];
  if (threshold >= dataLength || threshold === 0) {
    const allIndices = data.map((values, index) => index);
    return { downsampledData: data, downsampledIndices: allIndices };
  }
  const sampled = [];
  let sampledIndex = 0;
  const every = (dataLength - 2) / (threshold - 2);
  let a = 0;
  let maxAreaPoint;
  let maxArea;
  let area;
  let nextA;
  sampled.push(data[a]);
  downsampledIndices.push(0);
  for (let i = 0; i < threshold - 2; i++) {
    let avgX = 0;
    let avgY = 0;
    let avgRangeStart = Math.floor((i + 1) * every) + 1;
    let avgRangeEnd = Math.floor((i + 2) * every) + 1;
    avgRangeEnd = avgRangeEnd < dataLength ? avgRangeEnd : dataLength;
    const avgRangeLength = avgRangeEnd - avgRangeStart;
    for (; avgRangeStart < avgRangeEnd; avgRangeStart++) {
      avgX += Number(data[avgRangeStart][0]);
      avgY += data[avgRangeStart][1] * 1;
    }
    avgX /= avgRangeLength;
    avgY /= avgRangeLength;
    let rangeOffs = Math.floor((i + 0) * every) + 1;
    const rangeTo = Math.floor((i + 1) * every) + 1;
    const pointAX = Number(data[a][0]);
    const pointAY = data[a][1] * 1;
    maxArea = area = -1;
    let maxAreaIndex = rangeOffs;
    for (; rangeOffs < rangeTo; rangeOffs++) {
      area = Math.abs(
        (pointAX - avgX) * (data[rangeOffs][1] - pointAY) - (pointAX - Number(data[rangeOffs][0])) * (avgY - pointAY)
      ) * 0.5;
      if (area > maxArea || area === maxArea && preferredDownsampleIndices.has(rangeOffs)) {
        maxArea = area;
        maxAreaPoint = data[rangeOffs];
        nextA = rangeOffs;
        maxAreaIndex = rangeOffs;
      }
    }
    sampled[sampledIndex++] = maxAreaPoint;
    downsampledIndices.push(maxAreaIndex);
    a = nextA;
  }
  sampled[sampledIndex++] = data[dataLength - 1];
  downsampledIndices.push(dataLength - 1);
  return { downsampledData: sampled, downsampledIndices };
};
var strictlyCoerceYColumn = (column, options) => {
  const isNullCoercionEnabled = options.nullValueDisplay === "zero";
  const canLooselyCoerceSomeValues = column.findIndex(
    (value) => (0, numberUtils_exports.startsWithNumber)(`${value}`) || isNullCoercionEnabled && value === null
  ) >= 0;
  const coercedColumn = [];
  const canDownsampleColumn = !column.some((value) => {
    const coercedValue = Number(value);
    const coerceValueToZero = isNullCoercionEnabled && value === null;
    if (Number.isNaN(coercedValue) || coercedValue <= Number.MIN_SAFE_INTEGER || coercedValue >= Number.MAX_SAFE_INTEGER || typeof value !== "string" && typeof value !== "number" && !coerceValueToZero) {
      return true;
    }
    coercedColumn.push(coercedValue);
    return false;
  });
  return {
    canDownsampleColumn,
    canLooselyCoerceSomeValues,
    coercedColumn: canDownsampleColumn ? coercedColumn : []
  };
};
var strictlyCoerceXColumn = (column, fieldType) => {
  if (fieldType === "number") {
    const coercedXColumn = column.map((xValue) => Number(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  } else if (fieldType === "time") {
    const coercedXColumn = column.map((xValue) => new Date(xValue));
    if (isColumnStrictlyIncreasing(coercedXColumn, fieldType)) {
      return coercedXColumn;
    }
  }
  return [];
};
var isDownsamplingEnabledForViz = ({ vizConfig }) => {
  var _a;
  return (_a = vizConfig.supports) == null ? void 0 : _a.includes("downsampling" /* DOWNSAMPLING */);
};
var calculateThresholdOnRangeSelect = ({
  firstIndex,
  lastIndex,
  dataSources,
  width
}) => {
  var _a, _b, _c;
  const window = lastIndex - firstIndex + 1;
  const ratio = Math.round(Number(((_c = (_b = (_a = dataSources == null ? void 0 : dataSources.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.columns[0]) == null ? void 0 : _c.length) / window) * 10) / 10;
  return Math.round(ratio * Number(width));
};
var calculateDownsamplingThreshold = ({
  enableSearchZoom,
  dataSources,
  selectChartEvent,
  width,
  xField
}) => {
  var _a, _b, _c;
  if (enableSearchZoom || !selectChartEvent) {
    return Number(width);
  }
  const primaryDataSource = dataSources == null ? void 0 : dataSources.primary;
  if (!primaryDataSource) {
    return null;
  }
  const { startXIndex, endXIndex, currentTarget } = selectChartEvent;
  try {
    const xFieldIndex = (_a = primaryDataSource == null ? void 0 : primaryDataSource.data) == null ? void 0 : _a.fields.findIndex((field) => {
      const name = typeof field === "string" ? field : field.name;
      return name === xField;
    });
    const downsampledXFieldIndex = (_b = currentTarget.dataSet) == null ? void 0 : _b.fields.findIndex((field) => field === xField);
    if (xFieldIndex === -1 || downsampledXFieldIndex === -1) {
      return null;
    }
    const fullSeries = (_c = primaryDataSource == null ? void 0 : primaryDataSource.data) == null ? void 0 : _c.columns[xFieldIndex];
    const downsampledSeries = currentTarget.dataSet.seriesList[downsampledXFieldIndex];
    const firstIndex = fullSeries.findIndex((x) => {
      return downsampledSeries[startXIndex] === x;
    });
    const lastIndex = fullSeries.findIndex((x) => {
      return downsampledSeries[endXIndex] === x;
    });
    if (firstIndex >= 0 && lastIndex >= 0 && firstIndex <= lastIndex) {
      return calculateThresholdOnRangeSelect({
        firstIndex,
        lastIndex,
        dataSources,
        width
      });
    }
  } catch (e) {
    console.error("Error occurred while setting downsample threshold on range select event", e);
  }
  return null;
};
var isColumnStrictlyIncreasing = (column, fieldType) => {
  return column.every((value, index) => {
    if (fieldType === "number") {
      if (Number.isNaN(value)) {
        return false;
      }
    }
    if (fieldType === "time") {
      if (Number.isNaN(value.getTime())) {
        return false;
      }
    }
    if (index === 0) {
      return true;
    }
    return value > column[index - 1];
  });
};
var tryToCoerceAllDisplayedFields = (ds, xField, yFields, fieldTypes, options) => {
  let xColumn = [];
  const yColumns = [];
  const canDownsample = !ds.data.fields.some((field, index) => {
    var _a, _b;
    const fieldName = (_a = field.name) != null ? _a : field;
    const fieldType = (_b = fieldTypes[index]) != null ? _b : "unknown";
    const column = ds.data.columns[index];
    let hasDisplayedColumnThatCantBeDownsampled = false;
    if (fieldName === xField) {
      xColumn = strictlyCoerceXColumn(column, fieldType);
    } else if (yFields.has(fieldName)) {
      const { coercedColumn, canLooselyCoerceSomeValues, canDownsampleColumn } = strictlyCoerceYColumn(
        ds.data.columns[index],
        options
      );
      hasDisplayedColumnThatCantBeDownsampled = canLooselyCoerceSomeValues && !canDownsampleColumn;
      if (hasDisplayedColumnThatCantBeDownsampled) {
        return true;
      }
      if (canDownsampleColumn) {
        yColumns.push(coercedColumn);
      }
    }
    return false;
  });
  if (canDownsample) {
    return { xColumn, yColumns };
  }
  return { xColumn: [], yColumns: [] };
};
var pickIndicesFromDataSource = (ds, indices) => {
  const sortedIndices = Array.from(indices).sort((a, b) => a - b);
  const slicedColumns = [];
  ds.data.columns.forEach((column) => {
    const slicedColumn = [];
    sortedIndices.forEach((index) => {
      slicedColumn.push(column[index]);
    });
    slicedColumns.push(slicedColumn);
  });
  return __spreadProps(__spreadValues({}, ds), {
    data: __spreadProps(__spreadValues({}, ds.data), {
      columns: slicedColumns
    })
  });
};
var downsampleDataSources = ({ dataSources, threshold, options }) => {
  var _a, _b, _c;
  const primaryDS = dataSources == null ? void 0 : dataSources.primary;
  const numPoints = (_c = (_b = (_a = primaryDS == null ? void 0 : primaryDS.data) == null ? void 0 : _a.columns[0]) == null ? void 0 : _b.length) != null ? _c : 0;
  if (Number.isNaN(threshold) || numPoints <= threshold || threshold < 2) {
    return dataSources;
  }
  const { xField, yFields, fieldTypes } = options;
  if (!xField || !(yFields == null ? void 0 : yFields.length) || !(fieldTypes == null ? void 0 : fieldTypes.length)) {
    return dataSources;
  }
  const nonInternalYFields = new Set(yFields.filter((yField) => !yField.startsWith("_")));
  const maxPointsInDownsample = Math.min(nonInternalYFields.size * threshold, numPoints);
  if (maxPointsInDownsample >= numPoints) {
    return dataSources;
  }
  const { xColumn, yColumns } = tryToCoerceAllDisplayedFields(
    primaryDS,
    xField,
    nonInternalYFields,
    fieldTypes,
    options
  );
  if (!yColumns.length || !xColumn.length) {
    return dataSources;
  }
  const downsampledDataSources = __spreadValues({}, dataSources);
  const downsampledIndices = /* @__PURE__ */ new Set();
  yColumns.forEach((yColumn, columnIndex) => {
    const xyPair = yColumn.map((yValue, index) => {
      return [xColumn[index], yValue];
    });
    try {
      const { downsampledIndices: downsampledIndicesForSeries } = largestTriangleThreeBuckets(
        xyPair,
        threshold,
        downsampledIndices
      );
      downsampledIndicesForSeries.forEach((downsampleIndex) => downsampledIndices.add(downsampleIndex));
    } catch (e) {
      console.error(`Error occurred while downsampling column ${columnIndex}`, e);
    }
  });
  downsampledDataSources.primary = pickIndicesFromDataSource(primaryDS, downsampledIndices);
  return downsampledDataSources;
};
//# sourceMappingURL=dataUtils.js.map
