/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/common/utils/trellisUtils.ts
var trellisUtils_exports2 = {};
__export(trellisUtils_exports2, {
  AGGREGATIONS: () => AGGREGATIONS,
  dataSourcesSplitByAggregationsStats: () => dataSourcesSplitByAggregationsStats,
  dataSourcesSplitByAggregationsTimechartAndChart: () => dataSourcesSplitByAggregationsTimechartAndChart,
  dataSourcesSplitByAggregationsUnknown: () => dataSourcesSplitByAggregationsUnknown,
  dataSourcesSplitByModeChart: () => dataSourcesSplitByModeChart,
  dataSourcesSplitByModeStatsorUnknown: () => dataSourcesSplitByModeStatsorUnknown,
  dataSourcesSplitByModeTimechart: () => dataSourcesSplitByModeTimechart,
  determineMinMax: () => determineMinMax,
  getTrellisDataSourcesBySplitMode: () => getTrellisDataSourcesBySplitMode,
  turnOffLegendDisplayWhenTrellisIsOn: () => turnOffLegendDisplayWhenTrellisIsOn
});
module.exports = __toCommonJS(trellisUtils_exports2);

// esm-externals:lodash
var lodash_exports = {};
__export(lodash_exports, {
  default: () => lodash_default
});
var defaultImport = __toESM(require("lodash"));
__reExport(lodash_exports, require("lodash"));
var lodash_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualizations-shared/trellisUtils
var trellisUtils_exports = {};
__export(trellisUtils_exports, {
  default: () => trellisUtils_default
});
var defaultImport2 = __toESM(require("@splunk/visualizations-shared/trellisUtils"));
__reExport(trellisUtils_exports, require("@splunk/visualizations-shared/trellisUtils"));
var trellisUtils_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// src/common/utils/trellisUtils.ts
var AGGREGATIONS = "aggregations";
var dataSourcesSplitByAggregationsUnknown = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let errorCode = null;
  if (fields && fields.length) {
    splitDataSources = {};
    for (let i = 0; i < fields.length; i += 1) {
      const fieldName = fields[i].name;
      if (!(fieldName == null ? void 0 : fieldName.startsWith("_"))) {
        splitDataSources[fieldName] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[fieldName].primary.data.fields = [fields[i]];
        splitDataSources[fieldName].primary.data.columns = [columns[i]];
      }
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var toFieldEntries = (fields) => {
  return fields.map((field) => {
    if (typeof field === "string") {
      return { name: field };
    }
    return field;
  });
};
var dataSourcesSplitByAggregationsTimechartAndChart = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = toFieldEntries((_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields);
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
  }
  if (splitByFields && splitByFields.length > 0) {
    splitDataSources = {};
    splitByFields.forEach((splitByField) => {
      splitDataSources[splitByField] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[splitByField].primary.data.fields = [fields[0]];
      splitDataSources[splitByField].primary.data.columns = [columns[0]];
      fields.forEach((field, idx) => {
        const fieldName = field == null ? void 0 : field.name;
        if (fieldName !== "_time" && !(fieldName == null ? void 0 : fieldName.startsWith("_")) && field.data_source === splitByField) {
          splitDataSources[splitByField].primary.data.fields.push(field);
          splitDataSources[splitByField].primary.data.columns.push(columns[idx]);
        }
      });
    });
  } else if ((!splitByFields || !splitByFields.length) && fields.length > 1) {
    splitDataSources = {};
    for (let i = 1; i < fields.length; i += 1) {
      const fieldName = fields[i].name;
      if (!(fieldName == null ? void 0 : fieldName.startsWith("_"))) {
        splitDataSources[fieldName] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[fieldName].primary.data.fields = [fields[0], fields[i]];
        splitDataSources[fieldName].primary.data.columns = [columns[0], columns[i]];
      }
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByAggregationsStats = (dataSource) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractDataSourceAggregationKeysStats)(fields);
  }
  if (splitByFields && splitByFields.length > 0) {
    splitDataSources = {};
    splitByFields.forEach((splitByField) => {
      splitDataSources[splitByField] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[splitByField].primary.data.fields = [fields[0]];
      splitDataSources[splitByField].primary.data.columns = [columns[0]];
      const idx = fields.findIndex((field) => field.name === splitByField);
      if (idx > 0) {
        splitDataSources[splitByField].primary.data.fields.push(fields[idx]);
        splitDataSources[splitByField].primary.data.columns.push(columns[idx]);
      }
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeTimechart = (dataSource, splitBy) => {
  var _a, _b, _c, _d, _e;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractSplitByFieldsChartFields)(fields);
  }
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    splitDataSources = {};
    const dataSourceKeys = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
    const valueKeys = [];
    for (let i = 1; i < fields.length; i += 1) {
      if (!((_e = fields[i].name) == null ? void 0 : _e.startsWith("_"))) {
        valueKeys.push(fields[i].splitby_value ? fields[i].splitby_value : fields[i].name);
      }
    }
    valueKeys.forEach((val) => {
      splitDataSources[val] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[val].primary.data.fields = [
        { name: fields[0].name },
        ...dataSourceKeys.map((k) => ({
          name: k
        }))
      ];
      splitDataSources[val].primary.data.columns = [[...columns[0]]];
      dataSourceKeys.forEach((dsKey) => {
        fields.forEach((field, idx) => {
          if (field.data_source === dsKey && (field.splitby_value === val || field.name === val)) {
            splitDataSources[val].primary.data.columns.push([...columns[idx]]);
          }
        });
      });
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeChart = (dataSource, splitBy) => {
  var _a, _b, _c, _d;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = (0, trellisUtils_exports.extractSplitByFieldsChartFields)(fields);
  }
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    splitDataSources = {};
    const splitByFieldIdx = splitByFields.findIndex((f) => f === splitBy);
    const otherSplitBy = splitByFields.filter((f) => f !== splitBy);
    const dataSourceKeys = (0, trellisUtils_exports.extractDataSourceAggregationKeysChart)(fields);
    const nonDataSourceAggregations = [];
    if (!dataSourceKeys.length && fields[0].groupby_rank === "0" && fields.length && !fields[1].groupby_rank) {
      for (let i = 1; i < fields.length; i += 1) {
        nonDataSourceAggregations.push(fields[i].name);
      }
    }
    if (splitByFieldIdx === 0) {
      const valueKeys = (0, lodash_exports.cloneDeep)(columns[0]);
      valueKeys.forEach((val, idx) => {
        splitDataSources[val] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[val].primary.data.fields = [];
        if (otherSplitBy.length) {
          splitDataSources[val].primary.data.fields = [{ name: otherSplitBy[0] }];
        }
        if (dataSourceKeys.length) {
          const columnValues = [[]];
          splitDataSources[val].primary.data.fields = [
            ...splitDataSources[val].primary.data.fields,
            ...dataSourceKeys.map((k) => ({
              name: k
            }))
          ];
          dataSourceKeys.forEach(() => {
            columnValues.push([]);
          });
          for (let i = 1; i <= Math.ceil((fields.length - 1) / dataSourceKeys.length); i += 1) {
            columnValues[0].push(
              fields[i].splitby_value ? fields[i].splitby_value : fields[i].name
            );
            dataSourceKeys.forEach((dskey, dsIndx) => {
              const mul = (fields.length - 1) / dataSourceKeys.length;
              columnValues[dsIndx + 1].push(columns[i + dsIndx * mul][idx]);
            });
          }
          splitDataSources[val].primary.data.columns = columnValues;
        } else if (nonDataSourceAggregations.length) {
          const columnValues = [];
          fields.forEach((aggregationField, fieldIdx) => {
            if (fieldIdx > 0) {
              splitDataSources[val].primary.data.fields.push(aggregationField);
              columnValues.push([columns[fieldIdx][idx]]);
            }
          });
          splitDataSources[val].primary.data.columns = columnValues;
        }
      });
    } else {
      const valueKeys = [];
      for (let i = 1; i < fields.length; i += 1) {
        valueKeys.push(fields[i].splitby_value ? fields[i].splitby_value : fields[i].name);
      }
      valueKeys.forEach((val) => {
        splitDataSources[val] = (0, lodash_exports.cloneDeep)(
          (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
        );
        splitDataSources[val].primary.data.fields = [
          { name: otherSplitBy[0] },
          ...dataSourceKeys.map((k) => ({
            name: k
          }))
        ];
        splitDataSources[val].primary.data.columns = [[...columns[0]]];
        dataSourceKeys.forEach((dsKey) => {
          fields.forEach((field, idx) => {
            if (field.data_source === dsKey && (field.splitby_value === val || field.name === val)) {
              splitDataSources[val].primary.data.columns.push([...columns[idx]]);
            }
          });
        });
      });
    }
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var dataSourcesSplitByModeStatsorUnknown = (dataSource, splitBy, splitMode) => {
  var _a, _b, _c, _d, _e, _f;
  const fields = (_b = (_a = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _a.data) == null ? void 0 : _b.fields;
  const columns = (_d = (_c = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _c.data) == null ? void 0 : _d.columns;
  let splitDataSources = null;
  let splitByFields = [];
  let errorCode = null;
  if (typeof fields[0] !== "string") {
    splitByFields = splitMode !== trellisUtils_exports.UNKNOWN ? (0, trellisUtils_exports.extractSplitByFieldsForStats)(fields) : (0, trellisUtils_exports.extractSplitByFieldsForUnknown)(fields);
  }
  const splitByIndex = fields == null ? void 0 : fields.findIndex(
    (field) => field === splitBy || field.name === splitBy
  );
  if (splitByFields && splitByFields.indexOf(splitBy) > -1) {
    const splitByColumn = (_f = (_e = dataSource == null ? void 0 : dataSource.primary) == null ? void 0 : _e.data) == null ? void 0 : _f.columns[splitByIndex];
    splitDataSources = {};
    splitByColumn.forEach((val, idx) => {
      if (!splitDataSources[val]) {
        splitDataSources[val] = [idx];
      } else {
        splitDataSources[val].push(idx);
      }
    });
    const cloneFields = (0, lodash_exports.cloneDeep)(fields);
    cloneFields.splice(splitByIndex, 1);
    const valueKeys = Object.keys(splitDataSources);
    valueKeys.forEach((val) => {
      const valIndices = (0, lodash_exports.cloneDeep)(splitDataSources[val]);
      splitDataSources[val] = (0, lodash_exports.cloneDeep)(
        (0, lodash_exports.omit)(dataSource, ["primary.data.fields", "primary.data.columns"])
      );
      splitDataSources[val].primary.data.fields = cloneFields;
      splitDataSources[val].primary.data.columns = [];
      columns.forEach((col, idx) => {
        if (idx !== splitByIndex) {
          const newCol = valIndices.map((valIdx) => col[valIdx]);
          splitDataSources[val].primary.data.columns.push(newCol);
        }
      });
    });
  } else {
    errorCode = "INVALID_SPLIT_BY_FIELD";
  }
  return { splitDataSources, errorCode };
};
var getTrellisDataSourcesBySplitMode = (splitMode, dataSources, trellisSplitBy) => {
  let result = null;
  try {
    if (splitMode === trellisUtils_exports.TIMECHART) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsTimechartAndChart(dataSources) : dataSourcesSplitByModeTimechart(dataSources, trellisSplitBy);
    } else if (splitMode === trellisUtils_exports.STATS) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsStats(dataSources) : dataSourcesSplitByModeStatsorUnknown(dataSources, trellisSplitBy, trellisUtils_exports.STATS);
    } else if (splitMode === trellisUtils_exports.CHART) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsTimechartAndChart(dataSources) : dataSourcesSplitByModeChart(dataSources, trellisSplitBy);
    } else if (splitMode === trellisUtils_exports.UNKNOWN) {
      result = trellisSplitBy === AGGREGATIONS ? dataSourcesSplitByAggregationsUnknown(dataSources) : dataSourcesSplitByModeStatsorUnknown(dataSources, trellisSplitBy, trellisUtils_exports.UNKNOWN);
    }
  } catch (ex) {
    console.error("getTrellisDataSourcesBySplitMode ", ex);
    result = { splitDataSources: null, errorCode: "UNKNOWN" };
  }
  return result;
};
var turnOffLegendDisplayWhenTrellisIsOn = (isTrellisOn, options) => {
  if (isTrellisOn && !options.legendDisplay) {
    return {
      legendDisplay: "off"
    };
  }
  return {};
};
var calculateSharedMinMax = (splitData) => {
  let max = -Infinity;
  let min = Infinity;
  Object.keys(splitData).forEach((splitByKey) => {
    const datasources = splitData[splitByKey];
    Object.keys(datasources).forEach((datasourceName) => {
      const dataColumns = datasources[datasourceName].data.columns;
      dataColumns.forEach((column) => {
        column.forEach((point) => {
          const pointNumber = Number(point);
          if (pointNumber > max) {
            max = pointNumber;
          }
          if (pointNumber < min) {
            min = pointNumber;
          }
        });
      });
    });
  });
  return [min, max];
};
var determineMinMax = (splitData, trellisSharedScale, yAxisMin, yAxisMax, stackMode) => {
  if (!trellisSharedScale || stackMode === "stacked100" || yAxisMin !== "auto" && yAxisMax !== "auto")
    return [yAxisMin, yAxisMax];
  const [sharedMin, sharedMax] = calculateSharedMinMax(splitData);
  const shouldUseSharedMax = sharedMax !== -Infinity && yAxisMax === "auto";
  const shouldUseSharedMin = sharedMin !== Infinity && yAxisMin === "auto";
  return [shouldUseSharedMin ? sharedMin : yAxisMin, shouldUseSharedMax ? sharedMax : yAxisMax];
};
//# sourceMappingURL=trellisUtils.js.map
